"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AlternateMailbox_1 = require("./AlternateMailbox");
var XmlElementNames_1 = require("../Core/XmlElementNames");
/**
 * Represents a user setting that is a collection of alternate mailboxes.
 * @sealed
 */
var AlternateMailboxCollection = /** @class */ (function () {
    function AlternateMailboxCollection() {
        this.entries = [];
    }
    Object.defineProperty(AlternateMailboxCollection.prototype, "Entries", {
        /**
         * Gets the collection of alternate mailboxes.
         */
        get: function () {
            return this.entries;
        },
        /** @private set */
        set: function (value) {
            this.entries = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @internal Loads instance of AlternateMailboxCollection.
     *
     * @param   {any} jsObject  Json Object converted from XML.
     * @returns {AlternateMailboxCollection}
     */
    AlternateMailboxCollection.LoadFromXmlJsObject = function (obj) {
        var instance = new AlternateMailboxCollection();
        var element = XmlElementNames_1.XmlElementNames.AlternateMailbox;
        var responses = undefined;
        if (Array.isArray(obj[element]))
            responses = obj[element];
        else
            responses = [obj[element]];
        for (var i = 0; i < responses.length; i++) {
            instance.Entries.push(AlternateMailbox_1.AlternateMailbox.LoadFromXmlJsObject(responses[i]));
        }
        return instance;
    };
    return AlternateMailboxCollection;
}());
exports.AlternateMailboxCollection = AlternateMailboxCollection;
//# sourceMappingURL=AlternateMailboxCollection.js.map