"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AutodiscoverResponse_1 = require("./Responses/AutodiscoverResponse");
/**
 * Represents a collection of responses to a call to the Autodiscover service.
 * @typeparam {TResponse} The type of the responses in the collection.
 */
var AutodiscoverResponseCollection = /** @class */ (function (_super) {
    __extends(AutodiscoverResponseCollection, _super);
    /**
     * @internal Initializes a new instance of the **AutodiscoverResponseCollection<TResponse>** class.
     */
    function AutodiscoverResponseCollection() {
        var _this = _super.call(this) || this;
        _this.responses = [];
        return _this;
    }
    Object.defineProperty(AutodiscoverResponseCollection.prototype, "Count", {
        /**
         * Gets the number of responses in the collection.
         */
        get: function () {
            return this.responses.length;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(AutodiscoverResponseCollection.prototype, "Responses", {
        /**
         * @internal Gets the responses list.
         */
        get: function () {
            return this.responses;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Gets the response at the specified index.
     *
     * @param   {number}   index   Index.
     * @returns {TResponse} TResponse at the index
     */
    AutodiscoverResponseCollection.prototype.__thisIndexer = function (index) {
        return this.Responses[index];
    };
    /**
     * Gets an enumerator that iterates through the elements of the collection.
     *
     * @return  {TResponse[]}      An IEnumerator for the collection.
     */
    AutodiscoverResponseCollection.prototype.GetEnumerator = function () {
        return this.responses;
    };
    /**
     * @internal Loads response from XML.
     *
     * @param   {any} responseObject  Json Object converted from XML.
     */
    AutodiscoverResponseCollection.prototype.LoadFromXmlJsObject = function (responseObject) {
        var element = this.GetResponseCollectionXmlElementName();
        _super.prototype.LoadFromXmlJsObject.call(this, responseObject);
        this.LoadResponseCollectionFromXmlJsObject(responseObject[element]);
    };
    /**
     * Loads the response collection from XML.
     *
     * @param   {any} jsObject  Json Object converted from XML.
     */
    AutodiscoverResponseCollection.prototype.LoadResponseCollectionFromXmlJsObject = function (jsObject) {
        var element = this.GetResponseInstanceXmlElementName();
        var responses = undefined;
        if (Array.isArray(jsObject[element]))
            responses = jsObject[element];
        else
            responses = [jsObject[element]];
        for (var i = 0; i < responses.length; i++) {
            var response = this.CreateResponseInstance();
            response.LoadFromXmlJsObject(responses[i]);
            this.Responses.push(response);
        }
    };
    return AutodiscoverResponseCollection;
}(AutodiscoverResponse_1.AutodiscoverResponse));
exports.AutodiscoverResponseCollection = AutodiscoverResponseCollection;
//# sourceMappingURL=AutodiscoverResponseCollection.js.map