"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ExtensionMethods_1 = require("../ExtensionMethods");
/**
 * @internal Represents a set of helper methods for performing string comparisons.
 * @static
 */
var ComparisonHelpers = /** @class */ (function () {
    function ComparisonHelpers() {
    }
    /**
     * Case insensitive check if the collection contains the string.
     *
     * @param   {any[]}   collection   The collection of objects, only strings are checked
     * @param   {string}  match        String to match
     * @return  {boolean}                true, if match contained in the collection
     */
    ComparisonHelpers.prototype.CaseInsensitiveContains = function (collection, match) {
        for (var _i = 0, collection_1 = collection; _i < collection_1.length; _i++) {
            var obj = collection_1[_i];
            var str = obj;
            if (str != null) {
                if (ExtensionMethods_1.StringHelper.Compare(str, match, true) == 0) {
                    return true;
                }
            }
        }
    };
    return ComparisonHelpers;
}());
exports.ComparisonHelpers = ComparisonHelpers;
//# sourceMappingURL=ComparisonHelpers.js.map