"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DocumentSharingLocation_1 = require("./DocumentSharingLocation");
var XmlElementNames_1 = require("../Core/XmlElementNames");
/**
 * Represents a user setting that is a collection of alternate mailboxes.
 * @sealed
 */
var DocumentSharingLocationCollection = /** @class */ (function () {
    /**
    * @internal Initializes a new instance of the **DocumentSharingLocationCollection** class.
    */
    function DocumentSharingLocationCollection() {
        this.entries = [];
    }
    Object.defineProperty(DocumentSharingLocationCollection.prototype, "Entries", {
        /**
         * Gets the collection of alternate mailboxes.
         */
        get: function () {
            return this.entries;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @internal Loads instance of DocumentSharingLocationCollection.
     *
     * @param   {any} jsObject  Json Object converted from XML.
     * @returns {DocumentSharingLocationCollection}
     */
    DocumentSharingLocationCollection.LoadFromXmlJsObject = function (jsObject) {
        var instance = new DocumentSharingLocationCollection();
        var element = XmlElementNames_1.XmlElementNames.DocumentSharingLocation;
        var responses = undefined;
        if (Array.isArray(jsObject[element]))
            responses = jsObject[element];
        else
            responses = [jsObject[element]];
        for (var i = 0; i < responses.length; i++) {
            instance.Entries.push(DocumentSharingLocation_1.DocumentSharingLocation.LoadFromXmlJsObject(responses[i]));
        }
        return instance;
    };
    return DocumentSharingLocationCollection;
}());
exports.DocumentSharingLocationCollection = DocumentSharingLocationCollection;
//# sourceMappingURL=DocumentSharingLocationCollection.js.map