"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ProtocolConnection_1 = require("./ProtocolConnection");
var XmlElementNames_1 = require("../Core/XmlElementNames");
/**
 * Represents a user setting that is a collection of protocol connection.
 * @sealed
 */
var ProtocolConnectionCollection = /** @class */ (function () {
    /**
     * @internal Initializes a new instance of the **ProtocolConnectionCollection** class.
     */
    function ProtocolConnectionCollection() {
        this.connections = [];
    }
    Object.defineProperty(ProtocolConnectionCollection.prototype, "Connections", {
        get: function () {
            return this.connections;
        },
        set: function (value) {
            this.connections = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @internal Read user setting with ProtocolConnectionCollection value.
     *
     * @param   {any} jsObject  Json Object converted from XML.
     * @returns {ProtocolConnectionCollection}
     */
    ProtocolConnectionCollection.LoadFromXmlJsObject = function (jsObject) {
        var value = new ProtocolConnectionCollection();
        var element = XmlElementNames_1.XmlElementNames.ProtocolConnection;
        var responses = undefined;
        if (Array.isArray(jsObject[element]))
            responses = jsObject[element];
        else
            responses = [jsObject[element]];
        for (var i = 0; i < responses.length; i++) {
            var connection = ProtocolConnection_1.ProtocolConnection.LoadFromXmlJsObject(responses[i]);
            value.Connections.push(connection);
        }
        return value;
    };
    return ProtocolConnectionCollection;
}());
exports.ProtocolConnectionCollection = ProtocolConnectionCollection;
//# sourceMappingURL=ProtocolConnectionCollection.js.map