"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var XmlElementNames_1 = require("../Core/XmlElementNames");
/**
 * Represents the URL of the Exchange web client.
 * @sealed
 */
var WebClientUrl = /** @class */ (function () {
    function WebClientUrl(authenticationMethods, url) {
        if (authenticationMethods === void 0) { authenticationMethods = null; }
        if (url === void 0) { url = null; }
        this.authenticationMethods = authenticationMethods;
        this.url = url;
    }
    Object.defineProperty(WebClientUrl.prototype, "AuthenticationMethods", {
        /**
         * Gets the authentication methods.
         */
        get: function () {
            return this.authenticationMethods;
        },
        /** @internal set */
        set: function (value) {
            this.authenticationMethods = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebClientUrl.prototype, "Url", {
        /**
         * Gets the URL.
         */
        get: function () {
            return this.url;
        },
        /** @internal set */
        set: function (value) {
            this.url = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @internal Loads WebClientUrl instance
     *
     * @param   {any} jsObject  Json Object converted from XML.
     * @returns {WebClientUrl}  WebClientUrl.
     */
    WebClientUrl.LoadFromXmlJsObject = function (jsObject) {
        var webClientUrl = new WebClientUrl();
        webClientUrl.AuthenticationMethods = jsObject[XmlElementNames_1.XmlElementNames.AuthenticationMethods];
        webClientUrl.Url = jsObject[XmlElementNames_1.XmlElementNames.Url];
        return webClientUrl;
    };
    return WebClientUrl;
}());
exports.WebClientUrl = WebClientUrl;
//# sourceMappingURL=WebClientUrl.js.map