"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var WebClientUrl_1 = require("./WebClientUrl");
var XmlElementNames_1 = require("../Core/XmlElementNames");
/**
 * Represents a user setting that is a collection of Exchange web client URLs.
 * @sealed
 */
var WebClientUrlCollection = /** @class */ (function () {
    /**
     * @internal Initializes a new instance of the **WebClientUrlCollection** class.
     */
    function WebClientUrlCollection() {
        this.urls = null;
        this.urls = [];
    }
    Object.defineProperty(WebClientUrlCollection.prototype, "Urls", {
        /**
         * Gets the URLs.
         */
        get: function () {
            return this.urls;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @internal Loads instance of WebClientUrlCollection.
     *
     * @param   {any} jsObject  Json Object converted from XML.
     * @returns {WebClientUrlCollection}
     */
    WebClientUrlCollection.LoadFromXmlJsObject = function (jsObject) {
        var instance = new WebClientUrlCollection();
        var element = XmlElementNames_1.XmlElementNames.WebClientUrl;
        var responses = undefined;
        if (Array.isArray(jsObject[element]))
            responses = jsObject[element];
        else
            responses = [jsObject[element]];
        for (var i = 0; i < responses.length; i++) {
            instance.Urls.push(WebClientUrl_1.WebClientUrl.LoadFromXmlJsObject(responses[i]));
        }
        return instance;
    };
    return WebClientUrlCollection;
}());
exports.WebClientUrlCollection = WebClientUrlCollection;
//# sourceMappingURL=WebClientUrlCollection.js.map