"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AutodiscoverError_1 = require("../Autodiscover/AutodiscoverError");
var ServiceRemoteException_1 = require("./ServiceRemoteException");
/**
 * Represents an exception that is thrown when the Autodiscover service returns an error.
 */
var AutodiscoverRemoteException = /** @class */ (function (_super) {
    __extends(AutodiscoverRemoteException, _super);
    function AutodiscoverRemoteException(errorOrMessage, error, innerException) {
        if (error === void 0) { error = null; }
        if (innerException === void 0) { innerException = null; }
        var _this = this;
        var _error = null;
        var message = null;
        if (arguments.length === 1 && errorOrMessage instanceof AutodiscoverError_1.AutodiscoverError) {
            error = errorOrMessage;
        }
        if (arguments.length >= 2) {
            if (typeof errorOrMessage === 'string') {
                message = errorOrMessage;
                _error = error;
            }
        }
        _this = _super.call(this, message, innerException) || this;
        _this.error = _error;
        return _this;
    }
    Object.defineProperty(AutodiscoverRemoteException.prototype, "Error", {
        /**
         * Gets the error.
         *  @value the Error
         */
        get: function () {
            return this.error;
        },
        enumerable: true,
        configurable: true
    });
    return AutodiscoverRemoteException;
}(ServiceRemoteException_1.ServiceRemoteException));
exports.AutodiscoverRemoteException = AutodiscoverRemoteException;
//# sourceMappingURL=AutodiscoverRemoteException.js.map