"use strict";
/**
 * BootStrap code. to initializes some class to avoid circular reference.
 */
Object.defineProperty(exports, "__esModule", { value: true });
/** polyfill */
if (typeof Object.assign != 'function') {
    // Must be writable: true, enumerable: false, configurable: true
    Object.defineProperty(Object, "assign", {
        value: function assign(target, varArgs) {
            'use strict';
            if (target == null) { // TypeError if undefined or null
                throw new TypeError('Cannot convert undefined or null to object');
            }
            var to = Object(target);
            for (var index = 1; index < arguments.length; index++) {
                var nextSource = arguments[index];
                if (nextSource != null) { // Skip over if undefined or null
                    for (var nextKey in nextSource) {
                        // Avoid bugs when hasOwnProperty is shadowed
                        if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
                            to[nextKey] = nextSource[nextKey];
                        }
                    }
                }
            }
            return to;
        },
        writable: true,
        configurable: true
    });
}
/** Promise type setup */
var Promise_1 = require("./Promise");
exports.Promise = Promise_1.Promise;
var ConfigurationApi_1 = require("./ConfigurationApi");
exports.ConfigurationApi = ConfigurationApi_1.ConfigurationApi;
var XHRFactory_1 = require("./XHRFactory");
exports.XHRFactory = XHRFactory_1.XHRFactory;
var XHRDefault_1 = require("./XHRDefault");
exports.XHRDefault = XHRDefault_1.XHRDefault;
/**Schema Bootstrapping */
var Schemas_1 = require("./Core/ServiceObjects/Schemas/Schemas");
var ServiceObjectSchema_1 = require("./Core/ServiceObjects/Schemas/ServiceObjectSchema");
exports.ServiceObjectSchema = ServiceObjectSchema_1.ServiceObjectSchema;
var ConversationSchema_1 = require("./Core/ServiceObjects/Schemas/ConversationSchema"); // [ServiceObjectSchema]
exports.ConversationSchema = ConversationSchema_1.ConversationSchema;
Schemas_1.Schemas.ConversationSchema = ConversationSchema_1.ConversationSchema;
var FolderSchema_1 = require("./Core/ServiceObjects/Schemas/FolderSchema"); // [ServiceObjectSchema]
exports.FolderSchema = FolderSchema_1.FolderSchema;
Schemas_1.Schemas.FolderSchema = FolderSchema_1.FolderSchema;
var SearchFolderSchema_1 = require("./Core/ServiceObjects/Schemas/SearchFolderSchema"); // [FolderSchema]
exports.SearchFolderSchema = SearchFolderSchema_1.SearchFolderSchema;
Schemas_1.Schemas.SearchFolderSchema = SearchFolderSchema_1.SearchFolderSchema;
var ItemSchema_1 = require("./Core/ServiceObjects/Schemas/ItemSchema"); // [ServiceObjectSchema] AppointmentSchema
exports.ItemSchema = ItemSchema_1.ItemSchema;
Schemas_1.Schemas.ItemSchema = ItemSchema_1.ItemSchema;
var AppointmentSchema_1 = require("./Core/ServiceObjects/Schemas/AppointmentSchema"); // [ItemSchema]
exports.AppointmentSchema = AppointmentSchema_1.AppointmentSchema;
Schemas_1.Schemas.AppointmentSchema = AppointmentSchema_1.AppointmentSchema;
var ContactSchema_1 = require("./Core/ServiceObjects/Schemas/ContactSchema"); // [ItemSchema]
exports.ContactSchema = ContactSchema_1.ContactSchema;
Schemas_1.Schemas.ContactSchema = ContactSchema_1.ContactSchema;
var ContactGroupSchema_1 = require("./Core/ServiceObjects/Schemas/ContactGroupSchema"); // [ItemSchema] ContactSchema
exports.ContactGroupSchema = ContactGroupSchema_1.ContactGroupSchema;
Schemas_1.Schemas.ContactGroupSchema = ContactGroupSchema_1.ContactGroupSchema;
var EmailMessageSchema_1 = require("./Core/ServiceObjects/Schemas/EmailMessageSchema"); // [ItemSchema]
exports.EmailMessageSchema = EmailMessageSchema_1.EmailMessageSchema;
Schemas_1.Schemas.EmailMessageSchema = EmailMessageSchema_1.EmailMessageSchema;
var MeetingMessageSchema_1 = require("./Core/ServiceObjects/Schemas/MeetingMessageSchema"); // [EmailMessageSchema] AppointmentSchema
exports.MeetingMessageSchema = MeetingMessageSchema_1.MeetingMessageSchema;
Schemas_1.Schemas.MeetingMessageSchema = MeetingMessageSchema_1.MeetingMessageSchema;
var MeetingCancellationSchema_1 = require("./Core/ServiceObjects/Schemas/MeetingCancellationSchema"); // [MeetingMessageSchema] AppointmentSchema
exports.MeetingCancellationSchema = MeetingCancellationSchema_1.MeetingCancellationSchema;
Schemas_1.Schemas.MeetingCancellationSchema = MeetingCancellationSchema_1.MeetingCancellationSchema;
var MeetingResponseSchema_1 = require("./Core/ServiceObjects/Schemas/MeetingResponseSchema"); // [MeetingMessageSchema] AppointmentSchema
exports.MeetingResponseSchema = MeetingResponseSchema_1.MeetingResponseSchema;
Schemas_1.Schemas.MeetingResponseSchema = MeetingResponseSchema_1.MeetingResponseSchema;
var MeetingRequestSchema_1 = require("./Core/ServiceObjects/Schemas/MeetingRequestSchema"); // [MeetingMessageSchema] AppointmentSchema
exports.MeetingRequestSchema = MeetingRequestSchema_1.MeetingRequestSchema;
Schemas_1.Schemas.MeetingRequestSchema = MeetingRequestSchema_1.MeetingRequestSchema;
var PostItemSchema_1 = require("./Core/ServiceObjects/Schemas/PostItemSchema"); // [ItemSchema] EmailMessageSchema
exports.PostItemSchema = PostItemSchema_1.PostItemSchema;
Schemas_1.Schemas.PostItemSchema = PostItemSchema_1.PostItemSchema;
var TaskSchema_1 = require("./Core/ServiceObjects/Schemas/TaskSchema"); // [ItemSchema]
exports.TaskSchema = TaskSchema_1.TaskSchema;
Schemas_1.Schemas.TaskSchema = TaskSchema_1.TaskSchema;
var ResponseObjectSchema_1 = require("./Core/ServiceObjects/Schemas/ResponseObjectSchema"); // [ServiceObjectSchema]
exports.ResponseObjectSchema = ResponseObjectSchema_1.ResponseObjectSchema;
Schemas_1.Schemas.ResponseObjectSchema = ResponseObjectSchema_1.ResponseObjectSchema;
var PostReplySchema_1 = require("./Core/ServiceObjects/Schemas/PostReplySchema"); // [ServiceObjectSchema] ItemSchema, ResponseObjectSchema
exports.PostReplySchema = PostReplySchema_1.PostReplySchema;
Schemas_1.Schemas.PostReplySchema = PostReplySchema_1.PostReplySchema;
var ResponseMessageSchema_1 = require("./Core/ServiceObjects/Schemas/ResponseMessageSchema"); // [ServiceObjectSchema] ItemSchema, EmailMessageSchema, ResponseObjectSchema
exports.ResponseMessageSchema = ResponseMessageSchema_1.ResponseMessageSchema;
Schemas_1.Schemas.ResponseMessageSchema = ResponseMessageSchema_1.ResponseMessageSchema;
var CancelMeetingMessageSchema_1 = require("./Core/ServiceObjects/Schemas/CancelMeetingMessageSchema"); // [ServiceObjectSchema] EmailMessageSchema, ResponseObjectSchema
exports.CancelMeetingMessageSchema = CancelMeetingMessageSchema_1.CancelMeetingMessageSchema;
Schemas_1.Schemas.CancelMeetingMessageSchema = CancelMeetingMessageSchema_1.CancelMeetingMessageSchema;
var CalendarResponseObjectSchema_1 = require("./Core/ServiceObjects/Schemas/CalendarResponseObjectSchema"); // [ServiceObjectSchema] ItemSchema, EmailMessageSchema, ResponseObjectSchema
exports.CalendarResponseObjectSchema = CalendarResponseObjectSchema_1.CalendarResponseObjectSchema;
Schemas_1.Schemas.CalendarResponseObjectSchema = CalendarResponseObjectSchema_1.CalendarResponseObjectSchema;
/**
 * Bootstrap typecontainer
 */
var TypeContainer_1 = require("./TypeContainer");
TypeContainer_1.TypeContainer.ServiceObjectSchema = ServiceObjectSchema_1.ServiceObjectSchema;
var ServiceObject_1 = require("./Core/ServiceObjects/ServiceObject");
exports.ServiceObject = ServiceObject_1.ServiceObject;
var Folder_1 = require("./Core/ServiceObjects/Folders/Folder");
exports.Folder = Folder_1.Folder;
var CalendarFolder_1 = require("./Core/ServiceObjects/Folders/CalendarFolder");
exports.CalendarFolder = CalendarFolder_1.CalendarFolder;
var ContactsFolder_1 = require("./Core/ServiceObjects/Folders/ContactsFolder");
exports.ContactsFolder = ContactsFolder_1.ContactsFolder;
var SearchFolder_1 = require("./Core/ServiceObjects/Folders/SearchFolder");
exports.SearchFolder = SearchFolder_1.SearchFolder;
var TasksFolder_1 = require("./Core/ServiceObjects/Folders/TasksFolder");
exports.TasksFolder = TasksFolder_1.TasksFolder;
var Appointment_1 = require("./Core/ServiceObjects/Items/Appointment");
exports.Appointment = Appointment_1.Appointment;
var Item_1 = require("./Core/ServiceObjects/Items/Item");
exports.Item = Item_1.Item;
var ItemAttachment_1 = require("./ComplexProperties/ItemAttachment");
exports.ItemAttachment = ItemAttachment_1.ItemAttachment;
var ItemAttachmentOf_1 = require("./ComplexProperties/ItemAttachmentOf");
exports.ItemAttachmentOf = ItemAttachmentOf_1.ItemAttachmentOf;
var MeetingCancellation_1 = require("./Core/ServiceObjects/Items/MeetingCancellation");
exports.MeetingCancellation = MeetingCancellation_1.MeetingCancellation;
var MeetingRequest_1 = require("./Core/ServiceObjects/Items/MeetingRequest");
exports.MeetingRequest = MeetingRequest_1.MeetingRequest;
var MeetingResponse_1 = require("./Core/ServiceObjects/Items/MeetingResponse");
exports.MeetingResponse = MeetingResponse_1.MeetingResponse;
var ExchangeService_1 = require("./Core/ExchangeService");
exports.ExchangeService = ExchangeService_1.ExchangeService;
var IndexedPropertyDefinition_1 = require("./PropertyDefinitions/IndexedPropertyDefinition");
exports.IndexedPropertyDefinition = IndexedPropertyDefinition_1.IndexedPropertyDefinition;
var ExtendedPropertyDefinition_1 = require("./PropertyDefinitions/ExtendedPropertyDefinition");
exports.ExtendedPropertyDefinition = ExtendedPropertyDefinition_1.ExtendedPropertyDefinition;
TypeContainer_1.TypeContainer.ServiceObject = ServiceObject_1.ServiceObject;
TypeContainer_1.TypeContainer.Folder = Folder_1.Folder;
TypeContainer_1.TypeContainer.CalendarFolder = CalendarFolder_1.CalendarFolder;
TypeContainer_1.TypeContainer.ContactsFolder = ContactsFolder_1.ContactsFolder;
TypeContainer_1.TypeContainer.SearchFolder = SearchFolder_1.SearchFolder;
TypeContainer_1.TypeContainer.TasksFolder = TasksFolder_1.TasksFolder;
TypeContainer_1.TypeContainer.Item = Item_1.Item;
TypeContainer_1.TypeContainer.Appointment = Appointment_1.Appointment;
TypeContainer_1.TypeContainer.MeetingRequest = MeetingRequest_1.MeetingRequest;
TypeContainer_1.TypeContainer.MeetingResponse = MeetingResponse_1.MeetingResponse;
TypeContainer_1.TypeContainer.MeetingCancellation = MeetingCancellation_1.MeetingCancellation;
TypeContainer_1.TypeContainer.ItemAttachment = ItemAttachment_1.ItemAttachment;
TypeContainer_1.TypeContainer.ItemAttachmentOf = ItemAttachmentOf_1.ItemAttachmentOf;
TypeContainer_1.TypeContainer.ExchangeService = ExchangeService_1.ExchangeService;
TypeContainer_1.TypeContainer.IndexedPropertyDefinition = IndexedPropertyDefinition_1.IndexedPropertyDefinition;
TypeContainer_1.TypeContainer.ExtendedPropertyDefinition = ExtendedPropertyDefinition_1.ExtendedPropertyDefinition;
/** TimeZoneTransitions */
var TimeZoneTransition_1 = require("./ComplexProperties/TimeZones/TimeZoneTransition");
exports.TimeZoneTransition = TimeZoneTransition_1.TimeZoneTransition;
var AbsoluteDateTransition_1 = require("./ComplexProperties/TimeZones/AbsoluteDateTransition");
exports.AbsoluteDateTransition = AbsoluteDateTransition_1.AbsoluteDateTransition;
var AbsoluteDayOfMonthTransition_1 = require("./ComplexProperties/TimeZones/AbsoluteDayOfMonthTransition");
exports.AbsoluteDayOfMonthTransition = AbsoluteDayOfMonthTransition_1.AbsoluteDayOfMonthTransition;
//import {AbsoluteMonthTransition} from "./ComplexProperties/TimeZones/AbsoluteMonthTransition";
var RelativeDayOfMonthTransition_1 = require("./ComplexProperties/TimeZones/RelativeDayOfMonthTransition");
exports.RelativeDayOfMonthTransition = RelativeDayOfMonthTransition_1.RelativeDayOfMonthTransition;
//export { TimeZoneDefinition } from "./ComplexProperties/TimeZones/TimeZoneDefinition";
var TimeZonePeriod_1 = require("./ComplexProperties/TimeZones/TimeZonePeriod");
exports.TimeZonePeriod = TimeZonePeriod_1.TimeZonePeriod;
TypeContainer_1.TypeContainer.AbsoluteDateTransition = AbsoluteDateTransition_1.AbsoluteDateTransition;
TypeContainer_1.TypeContainer.AbsoluteDayOfMonthTransition = AbsoluteDayOfMonthTransition_1.AbsoluteDayOfMonthTransition;
TypeContainer_1.TypeContainer.RelativeDayOfMonthTransition = RelativeDayOfMonthTransition_1.RelativeDayOfMonthTransition;
var Recurrence_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence");
exports.Recurrence = Recurrence_1.Recurrence;
var Recurrence_DailyPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.DailyPattern");
var Recurrence_DailyRegenerationPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.DailyRegenerationPattern");
var Recurrence_IntervalPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.IntervalPattern");
var Recurrence_MonthlyPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.MonthlyPattern");
var Recurrence_MonthlyRegenerationPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.MonthlyRegenerationPattern");
var Recurrence_RelativeMonthlyPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.RelativeMonthlyPattern");
var Recurrence_RelativeYearlyPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.RelativeYearlyPattern");
var Recurrence_WeeklyPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.WeeklyPattern");
var Recurrence_WeeklyRegenerationPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.WeeklyRegenerationPattern");
var Recurrence_YearlyPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.YearlyPattern");
var Recurrence_YearlyRegenerationPattern_1 = require("./ComplexProperties/Recurrence/Patterns/Recurrence.YearlyRegenerationPattern");
Recurrence_1.Recurrence.DailyPattern = Recurrence_DailyPattern_1.DailyPattern;
Recurrence_1.Recurrence.DailyRegenerationPattern = Recurrence_DailyRegenerationPattern_1.DailyRegenerationPattern;
Recurrence_1.Recurrence.IntervalPattern = Recurrence_IntervalPattern_1.IntervalPattern;
Recurrence_1.Recurrence.MonthlyPattern = Recurrence_MonthlyPattern_1.MonthlyPattern;
Recurrence_1.Recurrence.MonthlyRegenerationPattern = Recurrence_MonthlyRegenerationPattern_1.MonthlyRegenerationPattern;
Recurrence_1.Recurrence.RelativeMonthlyPattern = Recurrence_RelativeMonthlyPattern_1.RelativeMonthlyPattern;
Recurrence_1.Recurrence.RelativeYearlyPattern = Recurrence_RelativeYearlyPattern_1.RelativeYearlyPattern;
Recurrence_1.Recurrence.WeeklyPattern = Recurrence_WeeklyPattern_1.WeeklyPattern;
Recurrence_1.Recurrence.WeeklyRegenerationPattern = Recurrence_WeeklyRegenerationPattern_1.WeeklyRegenerationPattern;
Recurrence_1.Recurrence.YearlyPattern = Recurrence_YearlyPattern_1.YearlyPattern;
Recurrence_1.Recurrence.YearlyRegenerationPattern = Recurrence_YearlyRegenerationPattern_1.YearlyRegenerationPattern;
var SearchFilter_1 = require("./Search/Filters/SearchFilter");
exports.SearchFilter = SearchFilter_1.SearchFilter;
var SearchFilter_ContainsSubstring_1 = require("./Search/Filters/SearchFilter.ContainsSubstring");
var SearchFilter_ExcludesBitmask_1 = require("./Search/Filters/SearchFilter.ExcludesBitmask");
var SearchFilter_Exists_1 = require("./Search/Filters/SearchFilter.Exists");
var SearchFilter_IsEqualTo_1 = require("./Search/Filters/SearchFilter.IsEqualTo");
var SearchFilter_IsGreaterThan_1 = require("./Search/Filters/SearchFilter.IsGreaterThan");
var SearchFilter_IsGreaterThanOrEqualTo_1 = require("./Search/Filters/SearchFilter.IsGreaterThanOrEqualTo");
var SearchFilter_IsLessThan_1 = require("./Search/Filters/SearchFilter.IsLessThan");
var SearchFilter_IsLessThanOrEqualTo_1 = require("./Search/Filters/SearchFilter.IsLessThanOrEqualTo");
var SearchFilter_IsNotEqualTo_1 = require("./Search/Filters/SearchFilter.IsNotEqualTo");
var SearchFilter_Not_1 = require("./Search/Filters/SearchFilter.Not");
var SearchFilter_PropertyBasedFilter_1 = require("./Search/Filters/SearchFilter.PropertyBasedFilter");
var SearchFilter_RelationalFilter_1 = require("./Search/Filters/SearchFilter.RelationalFilter");
var SearchFilter_SearchFilterCollection_1 = require("./Search/Filters/SearchFilter.SearchFilterCollection");
SearchFilter_1.SearchFilter.ContainsSubstring = SearchFilter_ContainsSubstring_1.ContainsSubstring;
SearchFilter_1.SearchFilter.ExcludesBitmask = SearchFilter_ExcludesBitmask_1.ExcludesBitmask;
SearchFilter_1.SearchFilter.Exists = SearchFilter_Exists_1.Exists;
SearchFilter_1.SearchFilter.IsEqualTo = SearchFilter_IsEqualTo_1.IsEqualTo;
SearchFilter_1.SearchFilter.IsGreaterThan = SearchFilter_IsGreaterThan_1.IsGreaterThan;
SearchFilter_1.SearchFilter.IsGreaterThanOrEqualTo = SearchFilter_IsGreaterThanOrEqualTo_1.IsGreaterThanOrEqualTo;
SearchFilter_1.SearchFilter.IsLessThan = SearchFilter_IsLessThan_1.IsLessThan;
SearchFilter_1.SearchFilter.IsLessThanOrEqualTo = SearchFilter_IsLessThanOrEqualTo_1.IsLessThanOrEqualTo;
SearchFilter_1.SearchFilter.IsNotEqualTo = SearchFilter_IsNotEqualTo_1.IsNotEqualTo;
SearchFilter_1.SearchFilter.Not = SearchFilter_Not_1.Not;
SearchFilter_1.SearchFilter.PropertyBasedFilter = SearchFilter_PropertyBasedFilter_1.PropertyBasedFilter;
SearchFilter_1.SearchFilter.RelationalFilter = SearchFilter_RelationalFilter_1.RelationalFilter;
SearchFilter_1.SearchFilter.SearchFilterCollection = SearchFilter_SearchFilterCollection_1.SearchFilterCollection;
/**#endregion BootStrap code */
var AbstractFolderIdWrapper_1 = require("./Misc/AbstractFolderIdWrapper");
exports.AbstractFolderIdWrapper = AbstractFolderIdWrapper_1.AbstractFolderIdWrapper;
var AbstractItemIdWrapper_1 = require("./Misc/AbstractItemIdWrapper");
exports.AbstractItemIdWrapper = AbstractItemIdWrapper_1.AbstractItemIdWrapper;
var AcceptMeetingInvitationMessage_1 = require("./Core/ServiceObjects/ResponseObjects/AcceptMeetingInvitationMessage");
exports.AcceptMeetingInvitationMessage = AcceptMeetingInvitationMessage_1.AcceptMeetingInvitationMessage;
var AccountIsLockedException_1 = require("./Exceptions/AccountIsLockedException");
exports.AccountIsLockedException = AccountIsLockedException_1.AccountIsLockedException;
var AddDelegateRequest_1 = require("./Core/Requests/AddDelegateRequest");
exports.AddDelegateRequest = AddDelegateRequest_1.AddDelegateRequest;
var AddressEntity_1 = require("./ComplexProperties/AddressEntity");
exports.AddressEntity = AddressEntity_1.AddressEntity;
var AddressEntityCollection_1 = require("./ComplexProperties/AddressEntityCollection");
exports.AddressEntityCollection = AddressEntityCollection_1.AddressEntityCollection;
var AffectedTaskOccurrence_1 = require("./Enumerations/AffectedTaskOccurrence");
exports.AffectedTaskOccurrence = AffectedTaskOccurrence_1.AffectedTaskOccurrence;
var AggregateType_1 = require("./Enumerations/AggregateType");
exports.AggregateType = AggregateType_1.AggregateType;
var AltDictionary_1 = require("./AltDictionary");
exports.Dictionary = AltDictionary_1.Dictionary;
var AlternateId_1 = require("./Misc/IdConversion/AlternateId");
exports.AlternateId = AlternateId_1.AlternateId;
var AlternateIdBase_1 = require("./Misc/IdConversion/AlternateIdBase");
exports.AlternateIdBase = AlternateIdBase_1.AlternateIdBase;
var AlternateMailbox_1 = require("./Autodiscover/AlternateMailbox");
exports.AlternateMailbox = AlternateMailbox_1.AlternateMailbox;
var AlternateMailboxCollection_1 = require("./Autodiscover/AlternateMailboxCollection");
exports.AlternateMailboxCollection = AlternateMailboxCollection_1.AlternateMailboxCollection;
var AlternatePublicFolderId_1 = require("./Misc/IdConversion/AlternatePublicFolderId");
exports.AlternatePublicFolderId = AlternatePublicFolderId_1.AlternatePublicFolderId;
var AlternatePublicFolderItemId_1 = require("./Misc/IdConversion/AlternatePublicFolderItemId");
exports.AlternatePublicFolderItemId = AlternatePublicFolderItemId_1.AlternatePublicFolderItemId;
var ApplyConversationActionRequest_1 = require("./Core/Requests/ApplyConversationActionRequest");
exports.ApplyConversationActionRequest = ApplyConversationActionRequest_1.ApplyConversationActionRequest;
var AppointmentOccurrenceId_1 = require("./ComplexProperties/AppointmentOccurrenceId");
exports.AppointmentOccurrenceId = AppointmentOccurrenceId_1.AppointmentOccurrenceId;
var AppointmentType_1 = require("./Enumerations/AppointmentType");
exports.AppointmentType = AppointmentType_1.AppointmentType;
var ApprovalRequestData_1 = require("./ComplexProperties/ApprovalRequestData");
exports.ApprovalRequestData = ApprovalRequestData_1.ApprovalRequestData;
var ArchiveItemRequest_1 = require("./Core/Requests/ArchiveItemRequest");
exports.ArchiveItemRequest = ArchiveItemRequest_1.ArchiveItemRequest;
var ArchiveItemResponse_1 = require("./Core/Responses/ArchiveItemResponse");
exports.ArchiveItemResponse = ArchiveItemResponse_1.ArchiveItemResponse;
var ArchiveTag_1 = require("./ComplexProperties/ArchiveTag");
exports.ArchiveTag = ArchiveTag_1.ArchiveTag;
var AsyncRequestResult_1 = require("./Core/Requests/AsyncRequestResult");
exports.AsyncRequestResult = AsyncRequestResult_1.AsyncRequestResult;
var Attachment_1 = require("./ComplexProperties/Attachment");
exports.Attachment = Attachment_1.Attachment;
var AttachmentCollection_1 = require("./ComplexProperties/AttachmentCollection");
exports.AttachmentCollection = AttachmentCollection_1.AttachmentCollection;
var AttachmentsPropertyDefinition_1 = require("./PropertyDefinitions/AttachmentsPropertyDefinition");
exports.AttachmentsPropertyDefinition = AttachmentsPropertyDefinition_1.AttachmentsPropertyDefinition;
var Attendee_1 = require("./ComplexProperties/Attendee");
exports.Attendee = Attendee_1.Attendee;
var AttendeeAvailability_1 = require("./Core/Responses/AttendeeAvailability");
exports.AttendeeAvailability = AttendeeAvailability_1.AttendeeAvailability;
var AttendeeCollection_1 = require("./ComplexProperties/AttendeeCollection");
exports.AttendeeCollection = AttendeeCollection_1.AttendeeCollection;
var AttendeeInfo_1 = require("./Misc/Availability/AttendeeInfo");
exports.AttendeeInfo = AttendeeInfo_1.AttendeeInfo;
var AutodiscoverDnsClient_1 = require("./Autodiscover/AutodiscoverDnsClient");
exports.AutodiscoverDnsClient = AutodiscoverDnsClient_1.AutodiscoverDnsClient;
var AutodiscoverEndpoints_1 = require("./Enumerations/AutodiscoverEndpoints");
exports.AutodiscoverEndpoints = AutodiscoverEndpoints_1.AutodiscoverEndpoints;
var AutodiscoverError_1 = require("./Autodiscover/AutodiscoverError");
exports.AutodiscoverError = AutodiscoverError_1.AutodiscoverError;
var AutodiscoverErrorCode_1 = require("./Enumerations/AutodiscoverErrorCode");
exports.AutodiscoverErrorCode = AutodiscoverErrorCode_1.AutodiscoverErrorCode;
var AutodiscoverLocalException_1 = require("./Exceptions/AutodiscoverLocalException");
exports.AutodiscoverLocalException = AutodiscoverLocalException_1.AutodiscoverLocalException;
var AutodiscoverRemoteException_1 = require("./Exceptions/AutodiscoverRemoteException");
exports.AutodiscoverRemoteException = AutodiscoverRemoteException_1.AutodiscoverRemoteException;
var AutodiscoverRequest_1 = require("./Autodiscover/Requests/AutodiscoverRequest");
exports.AutodiscoverRequest = AutodiscoverRequest_1.AutodiscoverRequest;
var AutodiscoverResponse_1 = require("./Autodiscover/Responses/AutodiscoverResponse");
exports.AutodiscoverResponse = AutodiscoverResponse_1.AutodiscoverResponse;
var AutodiscoverResponseCollection_1 = require("./Autodiscover/AutodiscoverResponseCollection");
exports.AutodiscoverResponseCollection = AutodiscoverResponseCollection_1.AutodiscoverResponseCollection;
var AutodiscoverResponseException_1 = require("./Exceptions/AutodiscoverResponseException");
exports.AutodiscoverResponseException = AutodiscoverResponseException_1.AutodiscoverResponseException;
var AutodiscoverResponseType_1 = require("./Enumerations/AutodiscoverResponseType");
exports.AutodiscoverResponseType = AutodiscoverResponseType_1.AutodiscoverResponseType;
var AutodiscoverService_1 = require("./Autodiscover/AutodiscoverService");
exports.AutodiscoverService = AutodiscoverService_1.AutodiscoverService;
var AvailabilityData_1 = require("./Enumerations/AvailabilityData");
exports.AvailabilityData = AvailabilityData_1.AvailabilityData;
var AvailabilityOptions_1 = require("./Misc/Availability/AvailabilityOptions");
exports.AvailabilityOptions = AvailabilityOptions_1.AvailabilityOptions;
var BasePropertySet_1 = require("./Enumerations/BasePropertySet");
exports.BasePropertySet = BasePropertySet_1.BasePropertySet;
//export {BasicAuthModuleForUTF8} from "./Credentials/BasicAuthModuleForUTF8";
var BatchServiceResponseException_1 = require("./Exceptions/BatchServiceResponseException");
exports.BatchServiceResponseException = BatchServiceResponseException_1.BatchServiceResponseException;
var BodyType_1 = require("./Enumerations/BodyType");
exports.BodyType = BodyType_1.BodyType;
var BoolPropertyDefinition_1 = require("./PropertyDefinitions/BoolPropertyDefinition");
exports.BoolPropertyDefinition = BoolPropertyDefinition_1.BoolPropertyDefinition;
//export {BulkTransfer} from "./operations/BulkTransfer/BulkTransfer";
var ByteArrayArray_1 = require("./ComplexProperties/ByteArrayArray");
exports.ByteArrayArray = ByteArrayArray_1.ByteArrayArray;
var ByteArrayPropertyDefinition_1 = require("./PropertyDefinitions/ByteArrayPropertyDefinition");
exports.ByteArrayPropertyDefinition = ByteArrayPropertyDefinition_1.ByteArrayPropertyDefinition;
var CalendarActionResults_1 = require("./Misc/CalendarActionResults");
exports.CalendarActionResults = CalendarActionResults_1.CalendarActionResults;
var CalendarEvent_1 = require("./ComplexProperties/Availability/CalendarEvent");
exports.CalendarEvent = CalendarEvent_1.CalendarEvent;
var CalendarEventDetails_1 = require("./ComplexProperties/Availability/CalendarEventDetails");
exports.CalendarEventDetails = CalendarEventDetails_1.CalendarEventDetails;
var CalendarResponseMessage_1 = require("./Core/ServiceObjects/ResponseObjects/CalendarResponseMessage");
exports.CalendarResponseMessage = CalendarResponseMessage_1.CalendarResponseMessage;
var CalendarResponseMessageBase_1 = require("./Core/ServiceObjects/ResponseObjects/CalendarResponseMessageBase");
exports.CalendarResponseMessageBase = CalendarResponseMessageBase_1.CalendarResponseMessageBase;
var CalendarView_1 = require("./Search/CalendarView");
exports.CalendarView = CalendarView_1.CalendarView;
var CancelMeetingMessage_1 = require("./Core/ServiceObjects/ResponseObjects/CancelMeetingMessage");
exports.CancelMeetingMessage = CancelMeetingMessage_1.CancelMeetingMessage;
var Change_1 = require("./Sync/Change");
exports.Change = Change_1.Change;
var ChangeCollection_1 = require("./Sync/ChangeCollection");
exports.ChangeCollection = ChangeCollection_1.ChangeCollection;
var ChangeHighlights_1 = require("./ComplexProperties/ChangeHighlights");
exports.ChangeHighlights = ChangeHighlights_1.ChangeHighlights;
var ChangeType_1 = require("./Enumerations/ChangeType");
exports.ChangeType = ChangeType_1.ChangeType;
var ClientAccessTokenRequest_1 = require("./ComplexProperties/ClientAccessTokenRequest");
exports.ClientAccessTokenRequest = ClientAccessTokenRequest_1.ClientAccessTokenRequest;
var ClientAccessTokenType_1 = require("./Enumerations/ClientAccessTokenType");
exports.ClientAccessTokenType = ClientAccessTokenType_1.ClientAccessTokenType;
var ClientApp_1 = require("./ComplexProperties/ClientApp");
exports.ClientApp = ClientApp_1.ClientApp;
var ClientAppMetadata_1 = require("./ComplexProperties/ClientAppMetadata");
exports.ClientAppMetadata = ClientAppMetadata_1.ClientAppMetadata;
var ClientCertificateCredentials_1 = require("./Credentials/ClientCertificateCredentials");
exports.ClientCertificateCredentials = ClientCertificateCredentials_1.ClientCertificateCredentials;
var ClientExtension_1 = require("./ComplexProperties/ClientExtension");
exports.ClientExtension = ClientExtension_1.ClientExtension;
var ClientExtensionProvidedTo_1 = require("./Enumerations/ClientExtensionProvidedTo");
exports.ClientExtensionProvidedTo = ClientExtensionProvidedTo_1.ClientExtensionProvidedTo;
var ComparisonHelpers_1 = require("./Autodiscover/ComparisonHelpers");
exports.ComparisonHelpers = ComparisonHelpers_1.ComparisonHelpers;
var ComparisonMode_1 = require("./Enumerations/ComparisonMode");
exports.ComparisonMode = ComparisonMode_1.ComparisonMode;
var CompleteName_1 = require("./ComplexProperties/CompleteName");
exports.CompleteName = CompleteName_1.CompleteName;
var ComplexProperty_1 = require("./ComplexProperties/ComplexProperty");
exports.ComplexProperty = ComplexProperty_1.ComplexProperty;
var ComplexPropertyCollection_1 = require("./ComplexProperties/ComplexPropertyCollection");
exports.ComplexPropertyCollection = ComplexPropertyCollection_1.ComplexPropertyCollection;
var ComplexPropertyDefinition_1 = require("./PropertyDefinitions/ComplexPropertyDefinition");
exports.ComplexPropertyDefinition = ComplexPropertyDefinition_1.ComplexPropertyDefinition;
var ComplexPropertyDefinitionBase_1 = require("./PropertyDefinitions/ComplexPropertyDefinitionBase");
exports.ComplexPropertyDefinitionBase = ComplexPropertyDefinitionBase_1.ComplexPropertyDefinitionBase;
var ConfigurationSettingsBase_1 = require("./Autodiscover/ConfigurationSettings/ConfigurationSettingsBase");
exports.ConfigurationSettingsBase = ConfigurationSettingsBase_1.ConfigurationSettingsBase;
var Conflict_1 = require("./ComplexProperties/Availability/Conflict");
exports.Conflict = Conflict_1.Conflict;
var ConflictResolutionMode_1 = require("./Enumerations/ConflictResolutionMode");
exports.ConflictResolutionMode = ConflictResolutionMode_1.ConflictResolutionMode;
var ConflictType_1 = require("./Enumerations/ConflictType");
exports.ConflictType = ConflictType_1.ConflictType;
var ConnectingIdType_1 = require("./Enumerations/ConnectingIdType");
exports.ConnectingIdType = ConnectingIdType_1.ConnectingIdType;
var ConnectionFailureCause_1 = require("./Enumerations/ConnectionFailureCause");
exports.ConnectionFailureCause = ConnectionFailureCause_1.ConnectionFailureCause;
//export {ConnectionStatus} from "./Enumerations/ConnectionStatus";
var Contact_1 = require("./Core/ServiceObjects/Items/Contact");
exports.Contact = Contact_1.Contact;
var ContactEntity_1 = require("./ComplexProperties/ContactEntity");
exports.ContactEntity = ContactEntity_1.ContactEntity;
var ContactEntityCollection_1 = require("./ComplexProperties/ContactEntityCollection");
exports.ContactEntityCollection = ContactEntityCollection_1.ContactEntityCollection;
var ContactGroup_1 = require("./Core/ServiceObjects/Items/ContactGroup");
exports.ContactGroup = ContactGroup_1.ContactGroup;
var ContactPhoneEntity_1 = require("./ComplexProperties/ContactPhoneEntity");
exports.ContactPhoneEntity = ContactPhoneEntity_1.ContactPhoneEntity;
var ContactPhoneEntityCollection_1 = require("./ComplexProperties/ContactPhoneEntityCollection");
exports.ContactPhoneEntityCollection = ContactPhoneEntityCollection_1.ContactPhoneEntityCollection;
var ContactSource_1 = require("./Enumerations/ContactSource");
exports.ContactSource = ContactSource_1.ContactSource;
var ContainedPropertyDefinition_1 = require("./PropertyDefinitions/ContainedPropertyDefinition");
exports.ContainedPropertyDefinition = ContainedPropertyDefinition_1.ContainedPropertyDefinition;
var ContainmentMode_1 = require("./Enumerations/ContainmentMode");
exports.ContainmentMode = ContainmentMode_1.ContainmentMode;
var Conversation_1 = require("./Core/ServiceObjects/Items/Conversation");
exports.Conversation = Conversation_1.Conversation;
var ConversationAction_1 = require("./Misc/ConversationAction");
exports.ConversationAction = ConversationAction_1.ConversationAction;
var ConversationActionType_1 = require("./Enumerations/ConversationActionType");
exports.ConversationActionType = ConversationActionType_1.ConversationActionType;
var ConversationFlagStatus_1 = require("./Enumerations/ConversationFlagStatus");
exports.ConversationFlagStatus = ConversationFlagStatus_1.ConversationFlagStatus;
var ConversationId_1 = require("./ComplexProperties/ConversationId");
exports.ConversationId = ConversationId_1.ConversationId;
var ConversationIndexedItemView_1 = require("./Search/ConversationIndexedItemView");
exports.ConversationIndexedItemView = ConversationIndexedItemView_1.ConversationIndexedItemView;
var ConversationNode_1 = require("./ComplexProperties/ConversationNode");
exports.ConversationNode = ConversationNode_1.ConversationNode;
var ConversationNodeCollection_1 = require("./ComplexProperties/ConversationNodeCollection");
exports.ConversationNodeCollection = ConversationNodeCollection_1.ConversationNodeCollection;
var ConversationQueryTraversal_1 = require("./Enumerations/ConversationQueryTraversal");
exports.ConversationQueryTraversal = ConversationQueryTraversal_1.ConversationQueryTraversal;
var ConversationRequest_1 = require("./ComplexProperties/ConversationRequest");
exports.ConversationRequest = ConversationRequest_1.ConversationRequest;
var ConversationResponse_1 = require("./ComplexProperties/ConversationResponse");
exports.ConversationResponse = ConversationResponse_1.ConversationResponse;
var ConversationSortOrder_1 = require("./Enumerations/ConversationSortOrder");
exports.ConversationSortOrder = ConversationSortOrder_1.ConversationSortOrder;
var ConvertIdRequest_1 = require("./Core/Requests/ConvertIdRequest");
exports.ConvertIdRequest = ConvertIdRequest_1.ConvertIdRequest;
var ConvertIdResponse_1 = require("./Core/Responses/ConvertIdResponse");
exports.ConvertIdResponse = ConvertIdResponse_1.ConvertIdResponse;
var CopyFolderRequest_1 = require("./Core/Requests/CopyFolderRequest");
exports.CopyFolderRequest = CopyFolderRequest_1.CopyFolderRequest;
var CopyItemRequest_1 = require("./Core/Requests/CopyItemRequest");
exports.CopyItemRequest = CopyItemRequest_1.CopyItemRequest;
var CreateAttachmentException_1 = require("./Exceptions/CreateAttachmentException");
exports.CreateAttachmentException = CreateAttachmentException_1.CreateAttachmentException;
var CreateAttachmentRequest_1 = require("./Core/Requests/CreateAttachmentRequest");
exports.CreateAttachmentRequest = CreateAttachmentRequest_1.CreateAttachmentRequest;
var CreateAttachmentResponse_1 = require("./Core/Responses/CreateAttachmentResponse");
exports.CreateAttachmentResponse = CreateAttachmentResponse_1.CreateAttachmentResponse;
var CreateFolderRequest_1 = require("./Core/Requests/CreateFolderRequest");
exports.CreateFolderRequest = CreateFolderRequest_1.CreateFolderRequest;
var CreateFolderResponse_1 = require("./Core/Responses/CreateFolderResponse");
exports.CreateFolderResponse = CreateFolderResponse_1.CreateFolderResponse;
var CreateItemRequest_1 = require("./Core/Requests/CreateItemRequest");
exports.CreateItemRequest = CreateItemRequest_1.CreateItemRequest;
var CreateItemRequestBase_1 = require("./Core/Requests/CreateItemRequestBase");
exports.CreateItemRequestBase = CreateItemRequestBase_1.CreateItemRequestBase;
var CreateItemResponse_1 = require("./Core/Responses/CreateItemResponse");
exports.CreateItemResponse = CreateItemResponse_1.CreateItemResponse;
var CreateItemResponseBase_1 = require("./Core/Responses/CreateItemResponseBase");
exports.CreateItemResponseBase = CreateItemResponseBase_1.CreateItemResponseBase;
var CreateRequest_1 = require("./Core/Requests/CreateRequest");
exports.CreateRequest = CreateRequest_1.CreateRequest;
var CreateResponseObjectRequest_1 = require("./Core/Requests/CreateResponseObjectRequest");
exports.CreateResponseObjectRequest = CreateResponseObjectRequest_1.CreateResponseObjectRequest;
var CreateResponseObjectResponse_1 = require("./Core/Responses/CreateResponseObjectResponse");
exports.CreateResponseObjectResponse = CreateResponseObjectResponse_1.CreateResponseObjectResponse;
var CreateRuleOperation_1 = require("./ComplexProperties/CreateRuleOperation");
exports.CreateRuleOperation = CreateRuleOperation_1.CreateRuleOperation;
var CreateUserConfigurationRequest_1 = require("./Core/Requests/CreateUserConfigurationRequest");
exports.CreateUserConfigurationRequest = CreateUserConfigurationRequest_1.CreateUserConfigurationRequest;
var DateTime_1 = require("./DateTime");
exports.DateTime = DateTime_1.DateTime;
exports.DateTimeKind = DateTime_1.DateTimeKind;
var TimeSpan_1 = require("./TimeSpan");
exports.TimeSpan = TimeSpan_1.TimeSpan;
var TimeZoneInfo_1 = require("./TimeZoneInfo");
exports.TimeZoneInfo = TimeZoneInfo_1.TimeZoneInfo;
var DateTimePrecision_1 = require("./Enumerations/DateTimePrecision");
exports.DateTimePrecision = DateTimePrecision_1.DateTimePrecision;
var DateTimePropertyDefinition_1 = require("./PropertyDefinitions/DateTimePropertyDefinition");
exports.DateTimePropertyDefinition = DateTimePropertyDefinition_1.DateTimePropertyDefinition;
var DayOfTheWeek_1 = require("./Enumerations/DayOfTheWeek");
exports.DayOfTheWeek = DayOfTheWeek_1.DayOfTheWeek;
var DayOfTheWeekCollection_1 = require("./ComplexProperties/Recurrence/DayOfTheWeekCollection");
exports.DayOfTheWeekCollection = DayOfTheWeekCollection_1.DayOfTheWeekCollection;
var DayOfTheWeekIndex_1 = require("./Enumerations/DayOfTheWeekIndex");
exports.DayOfTheWeekIndex = DayOfTheWeekIndex_1.DayOfTheWeekIndex;
var DeclineMeetingInvitationMessage_1 = require("./Core/ServiceObjects/ResponseObjects/DeclineMeetingInvitationMessage");
exports.DeclineMeetingInvitationMessage = DeclineMeetingInvitationMessage_1.DeclineMeetingInvitationMessage;
var DefaultExtendedPropertySet_1 = require("./Enumerations/DefaultExtendedPropertySet");
exports.DefaultExtendedPropertySet = DefaultExtendedPropertySet_1.DefaultExtendedPropertySet;
var DelegateFolderPermissionLevel_1 = require("./Enumerations/DelegateFolderPermissionLevel");
exports.DelegateFolderPermissionLevel = DelegateFolderPermissionLevel_1.DelegateFolderPermissionLevel;
var DelegateInformation_1 = require("./Misc/DelegateInformation");
exports.DelegateInformation = DelegateInformation_1.DelegateInformation;
var DelegateManagementRequestBase_1 = require("./Core/Requests/DelegateManagementRequestBase");
exports.DelegateManagementRequestBase = DelegateManagementRequestBase_1.DelegateManagementRequestBase;
var DelegateManagementResponse_1 = require("./Core/Responses/DelegateManagementResponse");
exports.DelegateManagementResponse = DelegateManagementResponse_1.DelegateManagementResponse;
var DelegatePermissions_1 = require("./ComplexProperties/DelegatePermissions");
exports.DelegatePermissions = DelegatePermissions_1.DelegatePermissions;
//export {DelegateTypes} from "./Misc/DelegateTypes";
var DelegateUser_1 = require("./ComplexProperties/DelegateUser");
exports.DelegateUser = DelegateUser_1.DelegateUser;
var DelegateUserResponse_1 = require("./Core/Responses/DelegateUserResponse");
exports.DelegateUserResponse = DelegateUserResponse_1.DelegateUserResponse;
var DeleteAttachmentException_1 = require("./Exceptions/DeleteAttachmentException");
exports.DeleteAttachmentException = DeleteAttachmentException_1.DeleteAttachmentException;
var DeleteAttachmentRequest_1 = require("./Core/Requests/DeleteAttachmentRequest");
exports.DeleteAttachmentRequest = DeleteAttachmentRequest_1.DeleteAttachmentRequest;
var DeleteAttachmentResponse_1 = require("./Core/Responses/DeleteAttachmentResponse");
exports.DeleteAttachmentResponse = DeleteAttachmentResponse_1.DeleteAttachmentResponse;
var DeletedOccurrenceInfo_1 = require("./ComplexProperties/DeletedOccurrenceInfo");
exports.DeletedOccurrenceInfo = DeletedOccurrenceInfo_1.DeletedOccurrenceInfo;
var DeletedOccurrenceInfoCollection_1 = require("./ComplexProperties/DeletedOccurrenceInfoCollection");
exports.DeletedOccurrenceInfoCollection = DeletedOccurrenceInfoCollection_1.DeletedOccurrenceInfoCollection;
var DeleteFolderRequest_1 = require("./Core/Requests/DeleteFolderRequest");
exports.DeleteFolderRequest = DeleteFolderRequest_1.DeleteFolderRequest;
var DeleteItemRequest_1 = require("./Core/Requests/DeleteItemRequest");
exports.DeleteItemRequest = DeleteItemRequest_1.DeleteItemRequest;
var DeleteMode_1 = require("./Enumerations/DeleteMode");
exports.DeleteMode = DeleteMode_1.DeleteMode;
var DeleteRequest_1 = require("./Core/Requests/DeleteRequest");
exports.DeleteRequest = DeleteRequest_1.DeleteRequest;
var DeleteRuleOperation_1 = require("./ComplexProperties/DeleteRuleOperation");
exports.DeleteRuleOperation = DeleteRuleOperation_1.DeleteRuleOperation;
var DeleteUserConfigurationRequest_1 = require("./Core/Requests/DeleteUserConfigurationRequest");
exports.DeleteUserConfigurationRequest = DeleteUserConfigurationRequest_1.DeleteUserConfigurationRequest;
var DictionaryEntryProperty_1 = require("./ComplexProperties/DictionaryEntryProperty");
exports.DictionaryEntryProperty = DictionaryEntryProperty_1.DictionaryEntryProperty;
var DictionaryProperty_1 = require("./ComplexProperties/DictionaryProperty");
exports.DictionaryProperty = DictionaryProperty_1.DictionaryProperty;
var DirectoryHelper_1 = require("./Autodiscover/DirectoryHelper");
exports.DirectoryHelper = DirectoryHelper_1.DirectoryHelper;
var DisableAppRequest_1 = require("./Core/Requests/DisableAppRequest");
exports.DisableAppRequest = DisableAppRequest_1.DisableAppRequest;
var DisableAppResponse_1 = require("./Core/Responses/DisableAppResponse");
exports.DisableAppResponse = DisableAppResponse_1.DisableAppResponse;
var DisableReasonType_1 = require("./Enumerations/DisableReasonType");
exports.DisableReasonType = DisableReasonType_1.DisableReasonType;
var DisconnectPhoneCallRequest_1 = require("./Core/Requests/DisconnectPhoneCallRequest");
exports.DisconnectPhoneCallRequest = DisconnectPhoneCallRequest_1.DisconnectPhoneCallRequest;
var DiscoverySearchConfiguration_1 = require("./MailboxSearch/DiscoverySearchConfiguration");
exports.DiscoverySearchConfiguration = DiscoverySearchConfiguration_1.DiscoverySearchConfiguration;
var DnsClient_1 = require("./Dns/DnsClient");
exports.DnsClient = DnsClient_1.DnsClient;
// export {DnsException} from "./Exceptions/DnsException";
// export {DnsNativeMethods} from "./Dns/DnsNativeMethods";
// export {DnsQueryOptions} from "./Enumerations/DnsQueryOptions";
var DnsRecord_1 = require("./Dns/DnsRecord");
exports.DnsRecord = DnsRecord_1.DnsRecord;
var DnsRecordHeader_1 = require("./Dns/DnsRecordHeader");
exports.DnsRecordHeader = DnsRecordHeader_1.DnsRecordHeader;
var DnsRecordType_1 = require("./Enumerations/DnsRecordType");
exports.DnsRecordType = DnsRecordType_1.DnsRecordType;
var DnsSrvRecord_1 = require("./Dns/DnsSrvRecord");
exports.DnsSrvRecord = DnsSrvRecord_1.DnsSrvRecord;
var DocumentSharingLocation_1 = require("./Autodiscover/DocumentSharingLocation");
exports.DocumentSharingLocation = DocumentSharingLocation_1.DocumentSharingLocation;
var DocumentSharingLocationCollection_1 = require("./Autodiscover/DocumentSharingLocationCollection");
exports.DocumentSharingLocationCollection = DocumentSharingLocationCollection_1.DocumentSharingLocationCollection;
var DomainSettingError_1 = require("./Autodiscover/DomainSettingError");
exports.DomainSettingError = DomainSettingError_1.DomainSettingError;
var DomainSettingName_1 = require("./Enumerations/DomainSettingName");
exports.DomainSettingName = DomainSettingName_1.DomainSettingName;
var DoublePropertyDefinition_1 = require("./PropertyDefinitions/DoublePropertyDefinition");
exports.DoublePropertyDefinition = DoublePropertyDefinition_1.DoublePropertyDefinition;
var EffectiveRights_1 = require("./Enumerations/EffectiveRights");
exports.EffectiveRights = EffectiveRights_1.EffectiveRights;
var EffectiveRightsPropertyDefinition_1 = require("./PropertyDefinitions/EffectiveRightsPropertyDefinition");
exports.EffectiveRightsPropertyDefinition = EffectiveRightsPropertyDefinition_1.EffectiveRightsPropertyDefinition;
var ElcFolderType_1 = require("./Enumerations/ElcFolderType");
exports.ElcFolderType = ElcFolderType_1.ElcFolderType;
var EmailAddress_1 = require("./ComplexProperties/EmailAddress");
exports.EmailAddress = EmailAddress_1.EmailAddress;
var EmailAddressCollection_1 = require("./ComplexProperties/EmailAddressCollection");
exports.EmailAddressCollection = EmailAddressCollection_1.EmailAddressCollection;
var EmailAddressDictionary_1 = require("./ComplexProperties/EmailAddressDictionary");
exports.EmailAddressDictionary = EmailAddressDictionary_1.EmailAddressDictionary;
var EmailAddressEntity_1 = require("./ComplexProperties/EmailAddressEntity");
exports.EmailAddressEntity = EmailAddressEntity_1.EmailAddressEntity;
var EmailAddressEntityCollection_1 = require("./ComplexProperties/EmailAddressEntityCollection");
exports.EmailAddressEntityCollection = EmailAddressEntityCollection_1.EmailAddressEntityCollection;
var EmailAddressEntry_1 = require("./ComplexProperties/EmailAddressEntry");
exports.EmailAddressEntry = EmailAddressEntry_1.EmailAddressEntry;
var EmailAddressKey_1 = require("./Enumerations/EmailAddressKey");
exports.EmailAddressKey = EmailAddressKey_1.EmailAddressKey;
var EmailMessage_1 = require("./Core/ServiceObjects/Items/EmailMessage");
exports.EmailMessage = EmailMessage_1.EmailMessage;
var EmailPosition_1 = require("./Enumerations/EmailPosition");
exports.EmailPosition = EmailPosition_1.EmailPosition;
var EmailUserEntity_1 = require("./ComplexProperties/EmailUserEntity");
exports.EmailUserEntity = EmailUserEntity_1.EmailUserEntity;
var EmailUserEntityCollection_1 = require("./ComplexProperties/EmailUserEntityCollection");
exports.EmailUserEntityCollection = EmailUserEntityCollection_1.EmailUserEntityCollection;
var EmptyFolderRequest_1 = require("./Core/Requests/EmptyFolderRequest");
exports.EmptyFolderRequest = EmptyFolderRequest_1.EmptyFolderRequest;
var EndDateRecurrenceRange_1 = require("./ComplexProperties/Recurrence/Ranges/EndDateRecurrenceRange");
exports.EndDateRecurrenceRange = EndDateRecurrenceRange_1.EndDateRecurrenceRange;
var EnhancedLocation_1 = require("./ComplexProperties/EnhancedLocation");
exports.EnhancedLocation = EnhancedLocation_1.EnhancedLocation;
var EntityExtractionResult_1 = require("./ComplexProperties/EntityExtractionResult");
exports.EntityExtractionResult = EntityExtractionResult_1.EntityExtractionResult;
var EventType_1 = require("./Enumerations/EventType");
exports.EventType = EventType_1.EventType;
var EwsLogging_1 = require("./Core/EwsLogging");
exports.EwsLogging = EwsLogging_1.EwsLogging;
var EwsServiceJsonReader_1 = require("./Core/EwsServiceJsonReader");
exports.EwsServiceJsonReader = EwsServiceJsonReader_1.EwsServiceJsonReader;
var EwsServiceMultiResponseXmlReader_1 = require("./Core/EwsServiceMultiResponseXmlReader");
exports.EwsServiceMultiResponseXmlReader = EwsServiceMultiResponseXmlReader_1.EwsServiceMultiResponseXmlReader;
var EwsServiceXmlReader_1 = require("./Core/EwsServiceXmlReader");
exports.EwsServiceXmlReader = EwsServiceXmlReader_1.EwsServiceXmlReader;
var EwsServiceXmlWriter_1 = require("./Core/EwsServiceXmlWriter");
exports.EwsServiceXmlWriter = EwsServiceXmlWriter_1.EwsServiceXmlWriter;
var EwsTraceListener_1 = require("./Misc/EwsTraceListener");
exports.EwsTraceListener = EwsTraceListener_1.EwsTraceListener;
var EwsUtilities_1 = require("./Core/EwsUtilities");
exports.EwsUtilities = EwsUtilities_1.EwsUtilities;
var EwsXmlReader_1 = require("./Core/EwsXmlReader");
exports.EwsXmlReader = EwsXmlReader_1.EwsXmlReader;
var Exception_1 = require("./Exceptions/Exception");
exports.Exception = Exception_1.Exception;
var ExchangeCredentials_1 = require("./Credentials/ExchangeCredentials");
exports.ExchangeCredentials = ExchangeCredentials_1.ExchangeCredentials;
var ExchangeServerInfo_1 = require("./Core/ExchangeServerInfo");
exports.ExchangeServerInfo = ExchangeServerInfo_1.ExchangeServerInfo;
var ExchangeServiceBase_1 = require("./Core/ExchangeServiceBase");
exports.ExchangeServiceBase = ExchangeServiceBase_1.ExchangeServiceBase;
var ExchangeVersion_1 = require("./Enumerations/ExchangeVersion");
exports.ExchangeVersion = ExchangeVersion_1.ExchangeVersion;
var ExecuteDiagnosticMethodRequest_1 = require("./Core/Requests/ExecuteDiagnosticMethodRequest");
exports.ExecuteDiagnosticMethodRequest = ExecuteDiagnosticMethodRequest_1.ExecuteDiagnosticMethodRequest;
var ExecuteDiagnosticMethodResponse_1 = require("./Core/Responses/ExecuteDiagnosticMethodResponse");
exports.ExecuteDiagnosticMethodResponse = ExecuteDiagnosticMethodResponse_1.ExecuteDiagnosticMethodResponse;
var ExpandGroupRequest_1 = require("./Core/Requests/ExpandGroupRequest");
exports.ExpandGroupRequest = ExpandGroupRequest_1.ExpandGroupRequest;
var ExpandGroupResponse_1 = require("./Core/Responses/ExpandGroupResponse");
exports.ExpandGroupResponse = ExpandGroupResponse_1.ExpandGroupResponse;
var ExpandGroupResults_1 = require("./Misc/ExpandGroupResults");
exports.ExpandGroupResults = ExpandGroupResults_1.ExpandGroupResults;
var ExtendedAttribute_1 = require("./MailboxSearch/ExtendedAttribute");
exports.ExtendedAttribute = ExtendedAttribute_1.ExtendedAttribute;
var ExtendedProperty_1 = require("./ComplexProperties/ExtendedProperty");
exports.ExtendedProperty = ExtendedProperty_1.ExtendedProperty;
var ExtendedPropertyCollection_1 = require("./ComplexProperties/ExtendedPropertyCollection");
exports.ExtendedPropertyCollection = ExtendedPropertyCollection_1.ExtendedPropertyCollection;
var ExtensionInstallScope_1 = require("./Enumerations/ExtensionInstallScope");
exports.ExtensionInstallScope = ExtensionInstallScope_1.ExtensionInstallScope;
var ExtensionMethods_1 = require("./ExtensionMethods");
exports.DOMParser = ExtensionMethods_1.DOMParser;
exports.isNullOrUndefined = ExtensionMethods_1.isNullOrUndefined;
exports.Convert = ExtensionMethods_1.Convert;
exports.ArrayHelper = ExtensionMethods_1.ArrayHelper;
exports.base64Helper = ExtensionMethods_1.base64Helper;
exports.EnumHelper = ExtensionMethods_1.EnumHelper;
exports.StringHelper = ExtensionMethods_1.StringHelper;
exports.TypeSystem = ExtensionMethods_1.TypeSystem;
exports.UriHelper = ExtensionMethods_1.UriHelper;
exports.xml2JsObject = ExtensionMethods_1.xml2JsObject;
var ExtensionType_1 = require("./Enumerations/ExtensionType");
exports.ExtensionType = ExtensionType_1.ExtensionType;
var ExtractedEntity_1 = require("./ComplexProperties/ExtractedEntity");
exports.ExtractedEntity = ExtractedEntity_1.ExtractedEntity;
var FailedSearchMailbox_1 = require("./MailboxSearch/FailedSearchMailbox");
exports.FailedSearchMailbox = FailedSearchMailbox_1.FailedSearchMailbox;
var FileAsMapping_1 = require("./Enumerations/FileAsMapping");
exports.FileAsMapping = FileAsMapping_1.FileAsMapping;
var FileAttachment_1 = require("./ComplexProperties/FileAttachment");
exports.FileAttachment = FileAttachment_1.FileAttachment;
var FindConversationRequest_1 = require("./Core/Requests/FindConversationRequest");
exports.FindConversationRequest = FindConversationRequest_1.FindConversationRequest;
var FindConversationResponse_1 = require("./Core/Responses/FindConversationResponse");
exports.FindConversationResponse = FindConversationResponse_1.FindConversationResponse;
var FindConversationResults_1 = require("./Search/FindConversationResults");
exports.FindConversationResults = FindConversationResults_1.FindConversationResults;
var FindFolderRequest_1 = require("./Core/Requests/FindFolderRequest");
exports.FindFolderRequest = FindFolderRequest_1.FindFolderRequest;
var FindFolderResponse_1 = require("./Core/Responses/FindFolderResponse");
exports.FindFolderResponse = FindFolderResponse_1.FindFolderResponse;
var FindFoldersResults_1 = require("./Search/FindFoldersResults");
exports.FindFoldersResults = FindFoldersResults_1.FindFoldersResults;
var FindItemRequest_1 = require("./Core/Requests/FindItemRequest");
exports.FindItemRequest = FindItemRequest_1.FindItemRequest;
var FindItemResponse_1 = require("./Core/Responses/FindItemResponse");
exports.FindItemResponse = FindItemResponse_1.FindItemResponse;
var FindItemsResults_1 = require("./Search/FindItemsResults");
exports.FindItemsResults = FindItemsResults_1.FindItemsResults;
var FindRequest_1 = require("./Core/Requests/FindRequest");
exports.FindRequest = FindRequest_1.FindRequest;
var Flag_1 = require("./ComplexProperties/Flag");
exports.Flag = Flag_1.Flag;
var FlaggedForAction_1 = require("./Enumerations/FlaggedForAction");
exports.FlaggedForAction = FlaggedForAction_1.FlaggedForAction;
var FolderChange_1 = require("./Sync/FolderChange");
exports.FolderChange = FolderChange_1.FolderChange;
var FolderEvent_1 = require("./Notifications/FolderEvent");
exports.FolderEvent = FolderEvent_1.FolderEvent;
var FolderId_1 = require("./ComplexProperties/FolderId");
exports.FolderId = FolderId_1.FolderId;
var FolderIdCollection_1 = require("./ComplexProperties/FolderIdCollection");
exports.FolderIdCollection = FolderIdCollection_1.FolderIdCollection;
var FolderIdWrapper_1 = require("./Misc/FolderIdWrapper");
exports.FolderIdWrapper = FolderIdWrapper_1.FolderIdWrapper;
var FolderIdWrapperList_1 = require("./Misc/FolderIdWrapperList");
exports.FolderIdWrapperList = FolderIdWrapperList_1.FolderIdWrapperList;
var FolderInfo_1 = require("./Core/ServiceObjects/Folders/FolderInfo");
exports.FolderInfo = FolderInfo_1.FolderInfo;
var FolderPermission_1 = require("./ComplexProperties/FolderPermission");
exports.FolderPermission = FolderPermission_1.FolderPermission;
var FolderPermissionCollection_1 = require("./ComplexProperties/FolderPermissionCollection");
exports.FolderPermissionCollection = FolderPermissionCollection_1.FolderPermissionCollection;
var FolderPermissionLevel_1 = require("./Enumerations/FolderPermissionLevel");
exports.FolderPermissionLevel = FolderPermissionLevel_1.FolderPermissionLevel;
var FolderPermissionReadAccess_1 = require("./Enumerations/FolderPermissionReadAccess");
exports.FolderPermissionReadAccess = FolderPermissionReadAccess_1.FolderPermissionReadAccess;
var FolderTraversal_1 = require("./Enumerations/FolderTraversal");
exports.FolderTraversal = FolderTraversal_1.FolderTraversal;
var FolderView_1 = require("./Search/FolderView");
exports.FolderView = FolderView_1.FolderView;
var FolderWrapper_1 = require("./Misc/FolderWrapper");
exports.FolderWrapper = FolderWrapper_1.FolderWrapper;
var FreeBusyViewType_1 = require("./Enumerations/FreeBusyViewType");
exports.FreeBusyViewType = FreeBusyViewType_1.FreeBusyViewType;
//export {FreeType} from "./Enumerations/FreeType"; - with DnsNativeMethods
var GenericPropertyDefinition_1 = require("./PropertyDefinitions/GenericPropertyDefinition");
exports.GenericPropertyDefinition = GenericPropertyDefinition_1.GenericPropertyDefinition;
var GetAppManifestsRequest_1 = require("./Core/Requests/GetAppManifestsRequest");
exports.GetAppManifestsRequest = GetAppManifestsRequest_1.GetAppManifestsRequest;
var GetAppManifestsResponse_1 = require("./Core/Responses/GetAppManifestsResponse");
exports.GetAppManifestsResponse = GetAppManifestsResponse_1.GetAppManifestsResponse;
var GetAppMarketplaceUrlRequest_1 = require("./Core/Requests/GetAppMarketplaceUrlRequest");
exports.GetAppMarketplaceUrlRequest = GetAppMarketplaceUrlRequest_1.GetAppMarketplaceUrlRequest;
var GetAppMarketplaceUrlResponse_1 = require("./Core/Responses/GetAppMarketplaceUrlResponse");
exports.GetAppMarketplaceUrlResponse = GetAppMarketplaceUrlResponse_1.GetAppMarketplaceUrlResponse;
var GetAttachmentRequest_1 = require("./Core/Requests/GetAttachmentRequest");
exports.GetAttachmentRequest = GetAttachmentRequest_1.GetAttachmentRequest;
var GetAttachmentResponse_1 = require("./Core/Responses/GetAttachmentResponse");
exports.GetAttachmentResponse = GetAttachmentResponse_1.GetAttachmentResponse;
var GetClientAccessTokenRequest_1 = require("./Core/Requests/GetClientAccessTokenRequest");
exports.GetClientAccessTokenRequest = GetClientAccessTokenRequest_1.GetClientAccessTokenRequest;
var GetClientAccessTokenResponse_1 = require("./Core/Responses/GetClientAccessTokenResponse");
exports.GetClientAccessTokenResponse = GetClientAccessTokenResponse_1.GetClientAccessTokenResponse;
var GetClientExtensionRequest_1 = require("./Core/Requests/GetClientExtensionRequest");
exports.GetClientExtensionRequest = GetClientExtensionRequest_1.GetClientExtensionRequest;
var GetClientExtensionResponse_1 = require("./Core/Responses/GetClientExtensionResponse");
exports.GetClientExtensionResponse = GetClientExtensionResponse_1.GetClientExtensionResponse;
var GetConversationItemsRequest_1 = require("./Core/Requests/GetConversationItemsRequest");
exports.GetConversationItemsRequest = GetConversationItemsRequest_1.GetConversationItemsRequest;
var GetConversationItemsResponse_1 = require("./Core/Responses/GetConversationItemsResponse");
exports.GetConversationItemsResponse = GetConversationItemsResponse_1.GetConversationItemsResponse;
var GetDelegateRequest_1 = require("./Core/Requests/GetDelegateRequest");
exports.GetDelegateRequest = GetDelegateRequest_1.GetDelegateRequest;
var GetDelegateResponse_1 = require("./Core/Responses/GetDelegateResponse");
exports.GetDelegateResponse = GetDelegateResponse_1.GetDelegateResponse;
var GetDiscoverySearchConfigurationRequest_1 = require("./Core/Requests/GetDiscoverySearchConfigurationRequest");
exports.GetDiscoverySearchConfigurationRequest = GetDiscoverySearchConfigurationRequest_1.GetDiscoverySearchConfigurationRequest;
var GetDiscoverySearchConfigurationResponse_1 = require("./Core/Responses/GetDiscoverySearchConfigurationResponse");
exports.GetDiscoverySearchConfigurationResponse = GetDiscoverySearchConfigurationResponse_1.GetDiscoverySearchConfigurationResponse;
var GetDomainSettingsRequest_1 = require("./Autodiscover/Requests/GetDomainSettingsRequest");
exports.GetDomainSettingsRequest = GetDomainSettingsRequest_1.GetDomainSettingsRequest;
var GetDomainSettingsResponse_1 = require("./Autodiscover/Responses/GetDomainSettingsResponse");
exports.GetDomainSettingsResponse = GetDomainSettingsResponse_1.GetDomainSettingsResponse;
var GetDomainSettingsResponseCollection_1 = require("./Autodiscover/Responses/GetDomainSettingsResponseCollection");
exports.GetDomainSettingsResponseCollection = GetDomainSettingsResponseCollection_1.GetDomainSettingsResponseCollection;
var GetEncryptionConfigurationRequest_1 = require("./Core/Requests/GetEncryptionConfigurationRequest");
exports.GetEncryptionConfigurationRequest = GetEncryptionConfigurationRequest_1.GetEncryptionConfigurationRequest;
var GetEncryptionConfigurationResponse_1 = require("./Core/Responses/GetEncryptionConfigurationResponse");
exports.GetEncryptionConfigurationResponse = GetEncryptionConfigurationResponse_1.GetEncryptionConfigurationResponse;
var GetEventsRequest_1 = require("./Core/Requests/GetEventsRequest");
exports.GetEventsRequest = GetEventsRequest_1.GetEventsRequest;
var GetEventsResponse_1 = require("./Core/Responses/GetEventsResponse");
exports.GetEventsResponse = GetEventsResponse_1.GetEventsResponse;
var GetEventsResults_1 = require("./Notifications/GetEventsResults");
exports.GetEventsResults = GetEventsResults_1.GetEventsResults;
var GetFolderRequest_1 = require("./Core/Requests/GetFolderRequest");
exports.GetFolderRequest = GetFolderRequest_1.GetFolderRequest;
var GetFolderRequestBase_1 = require("./Core/Requests/GetFolderRequestBase");
exports.GetFolderRequestBase = GetFolderRequestBase_1.GetFolderRequestBase;
var GetFolderRequestForLoad_1 = require("./Core/Requests/GetFolderRequestForLoad");
exports.GetFolderRequestForLoad = GetFolderRequestForLoad_1.GetFolderRequestForLoad;
var GetFolderResponse_1 = require("./Core/Responses/GetFolderResponse");
exports.GetFolderResponse = GetFolderResponse_1.GetFolderResponse;
var GetHoldOnMailboxesRequest_1 = require("./Core/Requests/GetHoldOnMailboxesRequest");
exports.GetHoldOnMailboxesRequest = GetHoldOnMailboxesRequest_1.GetHoldOnMailboxesRequest;
var GetHoldOnMailboxesResponse_1 = require("./Core/Responses/GetHoldOnMailboxesResponse");
exports.GetHoldOnMailboxesResponse = GetHoldOnMailboxesResponse_1.GetHoldOnMailboxesResponse;
var GetInboxRulesRequest_1 = require("./Core/Requests/GetInboxRulesRequest");
exports.GetInboxRulesRequest = GetInboxRulesRequest_1.GetInboxRulesRequest;
var GetInboxRulesResponse_1 = require("./Core/Responses/GetInboxRulesResponse");
exports.GetInboxRulesResponse = GetInboxRulesResponse_1.GetInboxRulesResponse;
var GetItemRequest_1 = require("./Core/Requests/GetItemRequest");
exports.GetItemRequest = GetItemRequest_1.GetItemRequest;
var GetItemRequestBase_1 = require("./Core/Requests/GetItemRequestBase");
exports.GetItemRequestBase = GetItemRequestBase_1.GetItemRequestBase;
var GetItemRequestForLoad_1 = require("./Core/Requests/GetItemRequestForLoad");
exports.GetItemRequestForLoad = GetItemRequestForLoad_1.GetItemRequestForLoad;
var GetItemResponse_1 = require("./Core/Responses/GetItemResponse");
exports.GetItemResponse = GetItemResponse_1.GetItemResponse;
var GetNonIndexableItemDetailsRequest_1 = require("./Core/Requests/GetNonIndexableItemDetailsRequest");
exports.GetNonIndexableItemDetailsRequest = GetNonIndexableItemDetailsRequest_1.GetNonIndexableItemDetailsRequest;
var GetNonIndexableItemDetailsResponse_1 = require("./Core/Responses/GetNonIndexableItemDetailsResponse");
exports.GetNonIndexableItemDetailsResponse = GetNonIndexableItemDetailsResponse_1.GetNonIndexableItemDetailsResponse;
var GetNonIndexableItemStatisticsRequest_1 = require("./Core/Requests/GetNonIndexableItemStatisticsRequest");
exports.GetNonIndexableItemStatisticsRequest = GetNonIndexableItemStatisticsRequest_1.GetNonIndexableItemStatisticsRequest;
var GetNonIndexableItemStatisticsResponse_1 = require("./Core/Responses/GetNonIndexableItemStatisticsResponse");
exports.GetNonIndexableItemStatisticsResponse = GetNonIndexableItemStatisticsResponse_1.GetNonIndexableItemStatisticsResponse;
var GetPasswordExpirationDateRequest_1 = require("./Core/Requests/GetPasswordExpirationDateRequest");
exports.GetPasswordExpirationDateRequest = GetPasswordExpirationDateRequest_1.GetPasswordExpirationDateRequest;
var GetPasswordExpirationDateResponse_1 = require("./Core/Responses/GetPasswordExpirationDateResponse");
exports.GetPasswordExpirationDateResponse = GetPasswordExpirationDateResponse_1.GetPasswordExpirationDateResponse;
var GetPhoneCallRequest_1 = require("./Core/Requests/GetPhoneCallRequest");
exports.GetPhoneCallRequest = GetPhoneCallRequest_1.GetPhoneCallRequest;
var GetPhoneCallResponse_1 = require("./Core/Responses/GetPhoneCallResponse");
exports.GetPhoneCallResponse = GetPhoneCallResponse_1.GetPhoneCallResponse;
var GetRequest_1 = require("./Core/Requests/GetRequest");
exports.GetRequest = GetRequest_1.GetRequest;
var GetRoomListsRequest_1 = require("./Core/Requests/GetRoomListsRequest");
exports.GetRoomListsRequest = GetRoomListsRequest_1.GetRoomListsRequest;
var GetRoomListsResponse_1 = require("./Core/Responses/GetRoomListsResponse");
exports.GetRoomListsResponse = GetRoomListsResponse_1.GetRoomListsResponse;
var GetRoomsRequest_1 = require("./Core/Requests/GetRoomsRequest");
exports.GetRoomsRequest = GetRoomsRequest_1.GetRoomsRequest;
var GetRoomsResponse_1 = require("./Core/Responses/GetRoomsResponse");
exports.GetRoomsResponse = GetRoomsResponse_1.GetRoomsResponse;
var GetSearchableMailboxesRequest_1 = require("./Core/Requests/GetSearchableMailboxesRequest");
exports.GetSearchableMailboxesRequest = GetSearchableMailboxesRequest_1.GetSearchableMailboxesRequest;
var GetSearchableMailboxesResponse_1 = require("./Core/Responses/GetSearchableMailboxesResponse");
exports.GetSearchableMailboxesResponse = GetSearchableMailboxesResponse_1.GetSearchableMailboxesResponse;
var GetServerTimeZonesRequest_1 = require("./Core/Requests/GetServerTimeZonesRequest");
exports.GetServerTimeZonesRequest = GetServerTimeZonesRequest_1.GetServerTimeZonesRequest;
var GetServerTimeZonesResponse_1 = require("./Core/Responses/GetServerTimeZonesResponse");
exports.GetServerTimeZonesResponse = GetServerTimeZonesResponse_1.GetServerTimeZonesResponse;
var GetStreamingEventsRequest_1 = require("./Core/Requests/GetStreamingEventsRequest");
exports.GetStreamingEventsRequest = GetStreamingEventsRequest_1.GetStreamingEventsRequest;
var GetStreamingEventsResponse_1 = require("./Core/Responses/GetStreamingEventsResponse");
exports.GetStreamingEventsResponse = GetStreamingEventsResponse_1.GetStreamingEventsResponse;
var GetStreamingEventsResults_1 = require("./Notifications/GetStreamingEventsResults");
exports.GetStreamingEventsResults = GetStreamingEventsResults_1.GetStreamingEventsResults;
var GetUserAvailabilityRequest_1 = require("./Core/Requests/GetUserAvailabilityRequest");
exports.GetUserAvailabilityRequest = GetUserAvailabilityRequest_1.GetUserAvailabilityRequest;
var GetUserAvailabilityResults_1 = require("./Misc/Availability/GetUserAvailabilityResults");
exports.GetUserAvailabilityResults = GetUserAvailabilityResults_1.GetUserAvailabilityResults;
var GetUserConfigurationRequest_1 = require("./Core/Requests/GetUserConfigurationRequest");
exports.GetUserConfigurationRequest = GetUserConfigurationRequest_1.GetUserConfigurationRequest;
var GetUserConfigurationResponse_1 = require("./Core/Responses/GetUserConfigurationResponse");
exports.GetUserConfigurationResponse = GetUserConfigurationResponse_1.GetUserConfigurationResponse;
var GetUserOofSettingsRequest_1 = require("./Core/Requests/GetUserOofSettingsRequest");
exports.GetUserOofSettingsRequest = GetUserOofSettingsRequest_1.GetUserOofSettingsRequest;
var GetUserOofSettingsResponse_1 = require("./Core/Responses/GetUserOofSettingsResponse");
exports.GetUserOofSettingsResponse = GetUserOofSettingsResponse_1.GetUserOofSettingsResponse;
var GetUserRetentionPolicyTagsRequest_1 = require("./Core/Requests/GetUserRetentionPolicyTagsRequest");
exports.GetUserRetentionPolicyTagsRequest = GetUserRetentionPolicyTagsRequest_1.GetUserRetentionPolicyTagsRequest;
var GetUserRetentionPolicyTagsResponse_1 = require("./Core/Responses/GetUserRetentionPolicyTagsResponse");
exports.GetUserRetentionPolicyTagsResponse = GetUserRetentionPolicyTagsResponse_1.GetUserRetentionPolicyTagsResponse;
var GetUserSettingsRequest_1 = require("./Autodiscover/Requests/GetUserSettingsRequest");
exports.GetUserSettingsRequest = GetUserSettingsRequest_1.GetUserSettingsRequest;
var GetUserSettingsResponse_1 = require("./Autodiscover/Responses/GetUserSettingsResponse");
exports.GetUserSettingsResponse = GetUserSettingsResponse_1.GetUserSettingsResponse;
var GetUserSettingsResponseCollection_1 = require("./Autodiscover/Responses/GetUserSettingsResponseCollection");
exports.GetUserSettingsResponseCollection = GetUserSettingsResponseCollection_1.GetUserSettingsResponseCollection;
var GroupedFindItemsResults_1 = require("./Search/GroupedFindItemsResults");
exports.GroupedFindItemsResults = GroupedFindItemsResults_1.GroupedFindItemsResults;
var Grouping_1 = require("./Search/Grouping");
exports.Grouping = Grouping_1.Grouping;
var GroupMember_1 = require("./ComplexProperties/GroupMember");
exports.GroupMember = GroupMember_1.GroupMember;
var GroupMemberCollection_1 = require("./ComplexProperties/GroupMemberCollection");
exports.GroupMemberCollection = GroupMemberCollection_1.GroupMemberCollection;
var GroupMemberPropertyDefinition_1 = require("./PropertyDefinitions/GroupMemberPropertyDefinition");
exports.GroupMemberPropertyDefinition = GroupMemberPropertyDefinition_1.GroupMemberPropertyDefinition;
var Guid_1 = require("./Guid");
exports.Guid = Guid_1.Guid;
var HangingRequestDisconnectEventArgs_1 = require("./Core/Requests/HangingRequestDisconnectEventArgs");
exports.HangingRequestDisconnectEventArgs = HangingRequestDisconnectEventArgs_1.HangingRequestDisconnectEventArgs;
var HangingRequestDisconnectReason_1 = require("./Enumerations/HangingRequestDisconnectReason");
exports.HangingRequestDisconnectReason = HangingRequestDisconnectReason_1.HangingRequestDisconnectReason;
var HangingServiceRequestBase_1 = require("./Core/Requests/HangingServiceRequestBase");
exports.HangingServiceRequestBase = HangingServiceRequestBase_1.HangingServiceRequestBase;
//export {HangingTraceStream} from "./Misc/HangingTraceStream";
var HighlightTerm_1 = require("./ComplexProperties/HighlightTerm");
exports.HighlightTerm = HighlightTerm_1.HighlightTerm;
var HoldAction_1 = require("./Enumerations/HoldAction");
exports.HoldAction = HoldAction_1.HoldAction;
var HoldStatus_1 = require("./Enumerations/HoldStatus");
exports.HoldStatus = HoldStatus_1.HoldStatus;
var IconIndex_1 = require("./Enumerations/IconIndex");
exports.IconIndex = IconIndex_1.IconIndex;
var IdFormat_1 = require("./Enumerations/IdFormat");
exports.IdFormat = IdFormat_1.IdFormat;
//export {IJSonSerializable} from "./Interfaces/IJSonSerializable";
var ImAddressDictionary_1 = require("./ComplexProperties/ImAddressDictionary");
exports.ImAddressDictionary = ImAddressDictionary_1.ImAddressDictionary;
var ImAddressEntry_1 = require("./ComplexProperties/ImAddressEntry");
exports.ImAddressEntry = ImAddressEntry_1.ImAddressEntry;
var ImAddressKey_1 = require("./Enumerations/ImAddressKey");
exports.ImAddressKey = ImAddressKey_1.ImAddressKey;
var ImpersonatedUserId_1 = require("./Misc/ImpersonatedUserId");
exports.ImpersonatedUserId = ImpersonatedUserId_1.ImpersonatedUserId;
var Importance_1 = require("./Enumerations/Importance");
exports.Importance = Importance_1.Importance;
var InstallAppRequest_1 = require("./Core/Requests/InstallAppRequest");
exports.InstallAppRequest = InstallAppRequest_1.InstallAppRequest;
var InstallAppResponse_1 = require("./Core/Responses/InstallAppResponse");
exports.InstallAppResponse = InstallAppResponse_1.InstallAppResponse;
var InternetMessageHeader_1 = require("./ComplexProperties/InternetMessageHeader");
exports.InternetMessageHeader = InternetMessageHeader_1.InternetMessageHeader;
var InternetMessageHeaderCollection_1 = require("./ComplexProperties/InternetMessageHeaderCollection");
exports.InternetMessageHeaderCollection = InternetMessageHeaderCollection_1.InternetMessageHeaderCollection;
var IntPropertyDefinition_1 = require("./PropertyDefinitions/IntPropertyDefinition");
exports.IntPropertyDefinition = IntPropertyDefinition_1.IntPropertyDefinition;
var ItemChange_1 = require("./Sync/ItemChange");
exports.ItemChange = ItemChange_1.ItemChange;
var ItemCollection_1 = require("./ComplexProperties/ItemCollection");
exports.ItemCollection = ItemCollection_1.ItemCollection;
var ItemEvent_1 = require("./Notifications/ItemEvent");
exports.ItemEvent = ItemEvent_1.ItemEvent;
var ItemFlagStatus_1 = require("./Enumerations/ItemFlagStatus");
exports.ItemFlagStatus = ItemFlagStatus_1.ItemFlagStatus;
var ItemGroup_1 = require("./Search/ItemGroup");
exports.ItemGroup = ItemGroup_1.ItemGroup;
var ItemId_1 = require("./ComplexProperties/ItemId");
exports.ItemId = ItemId_1.ItemId;
var ItemIdCollection_1 = require("./ComplexProperties/ItemIdCollection");
exports.ItemIdCollection = ItemIdCollection_1.ItemIdCollection;
var ItemIdWrapper_1 = require("./Misc/ItemIdWrapper");
exports.ItemIdWrapper = ItemIdWrapper_1.ItemIdWrapper;
var ItemIdWrapperList_1 = require("./Misc/ItemIdWrapperList");
exports.ItemIdWrapperList = ItemIdWrapperList_1.ItemIdWrapperList;
var ItemIndexError_1 = require("./Enumerations/ItemIndexError");
exports.ItemIndexError = ItemIndexError_1.ItemIndexError;
var ItemInfo_1 = require("./Core/ServiceObjects/Items/ItemInfo");
exports.ItemInfo = ItemInfo_1.ItemInfo;
var ItemTraversal_1 = require("./Enumerations/ItemTraversal");
exports.ItemTraversal = ItemTraversal_1.ItemTraversal;
var ItemView_1 = require("./Search/ItemView");
exports.ItemView = ItemView_1.ItemView;
var ItemWrapper_1 = require("./Misc/ItemWrapper");
exports.ItemWrapper = ItemWrapper_1.ItemWrapper;
var JsonDeserializationNotImplementedException_1 = require("./Exceptions/JsonDeserializationNotImplementedException");
exports.JsonDeserializationNotImplementedException = JsonDeserializationNotImplementedException_1.JsonDeserializationNotImplementedException;
var JsonNames_1 = require("./Core/JsonNames");
exports.JsonNames = JsonNames_1.JsonNames;
var JsonObject_1 = require("./Core/JsonObject");
exports.JsonObject = JsonObject_1.JsonObject;
var JsonParser_1 = require("./Core/JsonParser");
exports.JsonParser = JsonParser_1.JsonParser;
var JsonSerializationNotImplementedException_1 = require("./Exceptions/JsonSerializationNotImplementedException");
exports.JsonSerializationNotImplementedException = JsonSerializationNotImplementedException_1.JsonSerializationNotImplementedException;
var JsonTokenizer_1 = require("./Core/JsonTokenizer");
exports.JsonTokenizer = JsonTokenizer_1.JsonTokenizer;
var JsonTokenType_1 = require("./Enumerations/JsonTokenType");
exports.JsonTokenType = JsonTokenType_1.JsonTokenType;
var KeywordStatisticsSearchResult_1 = require("./MailboxSearch/KeywordStatisticsSearchResult");
exports.KeywordStatisticsSearchResult = KeywordStatisticsSearchResult_1.KeywordStatisticsSearchResult;
var LazyMember_1 = require("./Core/LazyMember");
exports.LazyMember = LazyMember_1.LazyMember;
var LegacyAvailabilityTimeZone_1 = require("./Misc/Availability/LegacyAvailabilityTimeZone");
exports.LegacyAvailabilityTimeZone = LegacyAvailabilityTimeZone_1.LegacyAvailabilityTimeZone;
var LegacyAvailabilityTimeZoneTime_1 = require("./Misc/Availability/LegacyAvailabilityTimeZoneTime");
exports.LegacyAvailabilityTimeZoneTime = LegacyAvailabilityTimeZoneTime_1.LegacyAvailabilityTimeZoneTime;
var LegacyFreeBusyStatus_1 = require("./Enumerations/LegacyFreeBusyStatus");
exports.LegacyFreeBusyStatus = LegacyFreeBusyStatus_1.LegacyFreeBusyStatus;
var ListValuePropertyDefinition_1 = require("./PropertyDefinitions/ListValuePropertyDefinition");
exports.ListValuePropertyDefinition = ListValuePropertyDefinition_1.ListValuePropertyDefinition;
var LobbyBypass_1 = require("./Enumerations/LobbyBypass");
exports.LobbyBypass = LobbyBypass_1.LobbyBypass;
var LocationSource_1 = require("./Enumerations/LocationSource");
exports.LocationSource = LocationSource_1.LocationSource;
var LogicalOperator_1 = require("./Enumerations/LogicalOperator");
exports.LogicalOperator = LogicalOperator_1.LogicalOperator;
var Mailbox_1 = require("./ComplexProperties/Mailbox");
exports.Mailbox = Mailbox_1.Mailbox;
var MailboxHoldResult_1 = require("./MailboxSearch/MailboxHoldResult");
exports.MailboxHoldResult = MailboxHoldResult_1.MailboxHoldResult;
var MailboxHoldStatus_1 = require("./MailboxSearch/MailboxHoldStatus");
exports.MailboxHoldStatus = MailboxHoldStatus_1.MailboxHoldStatus;
var MailboxQuery_1 = require("./MailboxSearch/MailboxQuery");
exports.MailboxQuery = MailboxQuery_1.MailboxQuery;
var MailboxSearchLocation_1 = require("./Enumerations/MailboxSearchLocation");
exports.MailboxSearchLocation = MailboxSearchLocation_1.MailboxSearchLocation;
var MailboxSearchScope_1 = require("./MailboxSearch/MailboxSearchScope");
exports.MailboxSearchScope = MailboxSearchScope_1.MailboxSearchScope;
var MailboxSearchScopeType_1 = require("./Enumerations/MailboxSearchScopeType");
exports.MailboxSearchScopeType = MailboxSearchScopeType_1.MailboxSearchScopeType;
var MailboxStatisticsItem_1 = require("./MailboxSearch/MailboxStatisticsItem");
exports.MailboxStatisticsItem = MailboxStatisticsItem_1.MailboxStatisticsItem;
var MailboxType_1 = require("./Enumerations/MailboxType");
exports.MailboxType = MailboxType_1.MailboxType;
//export {MailTips} from "./operations/MailTips/MailTips";
var ManagedFolderInformation_1 = require("./ComplexProperties/ManagedFolderInformation");
exports.ManagedFolderInformation = ManagedFolderInformation_1.ManagedFolderInformation;
var ManagementRoles_1 = require("./Misc/ManagementRoles");
exports.ManagementRoles = ManagementRoles_1.ManagementRoles;
var MapiPropertyType_1 = require("./Enumerations/MapiPropertyType");
exports.MapiPropertyType = MapiPropertyType_1.MapiPropertyType;
var MapiTypeConverter_1 = require("./Misc/MapiTypeConverter");
exports.MapiTypeConverter = MapiTypeConverter_1.MapiTypeConverter;
var MapiTypeConverterMapEntry_1 = require("./Misc/MapiTypeConverterMapEntry");
exports.MapiTypeConverterMapEntry = MapiTypeConverterMapEntry_1.MapiTypeConverterMapEntry;
var MarkAllItemsAsReadRequest_1 = require("./Core/Requests/MarkAllItemsAsReadRequest");
exports.MarkAllItemsAsReadRequest = MarkAllItemsAsReadRequest_1.MarkAllItemsAsReadRequest;
var MarkAsJunkRequest_1 = require("./Core/Requests/MarkAsJunkRequest");
exports.MarkAsJunkRequest = MarkAsJunkRequest_1.MarkAsJunkRequest;
var MarkAsJunkResponse_1 = require("./Core/Responses/MarkAsJunkResponse");
exports.MarkAsJunkResponse = MarkAsJunkResponse_1.MarkAsJunkResponse;
var MeetingAttendeeType_1 = require("./Enumerations/MeetingAttendeeType");
exports.MeetingAttendeeType = MeetingAttendeeType_1.MeetingAttendeeType;
var MeetingMessage_1 = require("./Core/ServiceObjects/Items/MeetingMessage");
exports.MeetingMessage = MeetingMessage_1.MeetingMessage;
var MeetingRequestsDeliveryScope_1 = require("./Enumerations/MeetingRequestsDeliveryScope");
exports.MeetingRequestsDeliveryScope = MeetingRequestsDeliveryScope_1.MeetingRequestsDeliveryScope;
var MeetingRequestType_1 = require("./Enumerations/MeetingRequestType");
exports.MeetingRequestType = MeetingRequestType_1.MeetingRequestType;
var MeetingResponseType_1 = require("./Enumerations/MeetingResponseType");
exports.MeetingResponseType = MeetingResponseType_1.MeetingResponseType;
var MeetingSuggestion_1 = require("./ComplexProperties/MeetingSuggestion");
exports.MeetingSuggestion = MeetingSuggestion_1.MeetingSuggestion;
var MeetingSuggestionCollection_1 = require("./ComplexProperties/MeetingSuggestionCollection");
exports.MeetingSuggestionCollection = MeetingSuggestionCollection_1.MeetingSuggestionCollection;
var MeetingTimeZone_1 = require("./ComplexProperties/MeetingTimeZone");
exports.MeetingTimeZone = MeetingTimeZone_1.MeetingTimeZone;
var MeetingTimeZonePropertyDefinition_1 = require("./PropertyDefinitions/MeetingTimeZonePropertyDefinition");
exports.MeetingTimeZonePropertyDefinition = MeetingTimeZonePropertyDefinition_1.MeetingTimeZonePropertyDefinition;
var MemberStatus_1 = require("./Enumerations/MemberStatus");
exports.MemberStatus = MemberStatus_1.MemberStatus;
var MessageBody_1 = require("./ComplexProperties/MessageBody");
exports.MessageBody = MessageBody_1.MessageBody;
var MessageDisposition_1 = require("./Enumerations/MessageDisposition");
exports.MessageDisposition = MessageDisposition_1.MessageDisposition;
//export {MessageTracking} from "./operations/MessageTracking/MessageTracking";
var MimeContent_1 = require("./ComplexProperties/MimeContent");
exports.MimeContent = MimeContent_1.MimeContent;
var MimeContentBase_1 = require("./ComplexProperties/MimeContentBase");
exports.MimeContentBase = MimeContentBase_1.MimeContentBase;
var MimeContentUTF8_1 = require("./ComplexProperties/MimeContentUTF8");
exports.MimeContentUTF8 = MimeContentUTF8_1.MimeContentUTF8;
var MobilePhone_1 = require("./Misc/MobilePhone");
exports.MobilePhone = MobilePhone_1.MobilePhone;
var Month_1 = require("./Enumerations/Month");
exports.Month = Month_1.Month;
var MoveCopyFolderRequest_1 = require("./Core/Requests/MoveCopyFolderRequest");
exports.MoveCopyFolderRequest = MoveCopyFolderRequest_1.MoveCopyFolderRequest;
var MoveCopyFolderResponse_1 = require("./Core/Responses/MoveCopyFolderResponse");
exports.MoveCopyFolderResponse = MoveCopyFolderResponse_1.MoveCopyFolderResponse;
var MoveCopyItemRequest_1 = require("./Core/Requests/MoveCopyItemRequest");
exports.MoveCopyItemRequest = MoveCopyItemRequest_1.MoveCopyItemRequest;
var MoveCopyItemResponse_1 = require("./Core/Responses/MoveCopyItemResponse");
exports.MoveCopyItemResponse = MoveCopyItemResponse_1.MoveCopyItemResponse;
var MoveCopyRequest_1 = require("./Core/Requests/MoveCopyRequest");
exports.MoveCopyRequest = MoveCopyRequest_1.MoveCopyRequest;
var MoveFolderRequest_1 = require("./Core/Requests/MoveFolderRequest");
exports.MoveFolderRequest = MoveFolderRequest_1.MoveFolderRequest;
var MoveItemRequest_1 = require("./Core/Requests/MoveItemRequest");
exports.MoveItemRequest = MoveItemRequest_1.MoveItemRequest;
var MultiResponseServiceRequest_1 = require("./Core/Requests/MultiResponseServiceRequest");
exports.MultiResponseServiceRequest = MultiResponseServiceRequest_1.MultiResponseServiceRequest;
var NameResolution_1 = require("./Misc/NameResolution");
exports.NameResolution = NameResolution_1.NameResolution;
var NameResolutionCollection_1 = require("./Misc/NameResolutionCollection");
exports.NameResolutionCollection = NameResolutionCollection_1.NameResolutionCollection;
var NoEndRecurrenceRange_1 = require("./ComplexProperties/Recurrence/Ranges/NoEndRecurrenceRange");
exports.NoEndRecurrenceRange = NoEndRecurrenceRange_1.NoEndRecurrenceRange;
var NonIndexableItem_1 = require("./MailboxSearch/NonIndexableItem");
exports.NonIndexableItem = NonIndexableItem_1.NonIndexableItem;
var NonIndexableItemDetailsResult_1 = require("./MailboxSearch/NonIndexableItemDetailsResult");
exports.NonIndexableItemDetailsResult = NonIndexableItemDetailsResult_1.NonIndexableItemDetailsResult;
var NonIndexableItemParameters_1 = require("./MailboxSearch/NonIndexableItemParameters");
exports.NonIndexableItemParameters = NonIndexableItemParameters_1.NonIndexableItemParameters;
exports.GetNonIndexableItemDetailsParameters = NonIndexableItemParameters_1.GetNonIndexableItemDetailsParameters;
exports.GetNonIndexableItemStatisticsParameters = NonIndexableItemParameters_1.GetNonIndexableItemStatisticsParameters;
var NonIndexableItemStatistic_1 = require("./MailboxSearch/NonIndexableItemStatistic");
exports.NonIndexableItemStatistic = NonIndexableItemStatistic_1.NonIndexableItemStatistic;
var NormalizedBody_1 = require("./ComplexProperties/NormalizedBody");
exports.NormalizedBody = NormalizedBody_1.NormalizedBody;
var NotificationEvent_1 = require("./Notifications/NotificationEvent");
exports.NotificationEvent = NotificationEvent_1.NotificationEvent;
var NotificationEventArgs_1 = require("./Notifications/NotificationEventArgs");
exports.NotificationEventArgs = NotificationEventArgs_1.NotificationEventArgs;
var NotificationGroup_1 = require("./Notifications/NotificationGroup");
exports.NotificationGroup = NotificationGroup_1.NotificationGroup;
var NumberedRecurrenceRange_1 = require("./ComplexProperties/Recurrence/Ranges/NumberedRecurrenceRange");
exports.NumberedRecurrenceRange = NumberedRecurrenceRange_1.NumberedRecurrenceRange;
var OAuthCredentials_1 = require("./Credentials/OAuthCredentials");
exports.OAuthCredentials = OAuthCredentials_1.OAuthCredentials;
var OccurrenceInfo_1 = require("./ComplexProperties/OccurrenceInfo");
exports.OccurrenceInfo = OccurrenceInfo_1.OccurrenceInfo;
var OccurrenceInfoCollection_1 = require("./ComplexProperties/OccurrenceInfoCollection");
exports.OccurrenceInfoCollection = OccurrenceInfoCollection_1.OccurrenceInfoCollection;
var OffsetBasePoint_1 = require("./Enumerations/OffsetBasePoint");
exports.OffsetBasePoint = OffsetBasePoint_1.OffsetBasePoint;
var OnlineMeetingAccessLevel_1 = require("./Enumerations/OnlineMeetingAccessLevel");
exports.OnlineMeetingAccessLevel = OnlineMeetingAccessLevel_1.OnlineMeetingAccessLevel;
var OnlineMeetingSettings_1 = require("./ComplexProperties/OnlineMeetingSettings");
exports.OnlineMeetingSettings = OnlineMeetingSettings_1.OnlineMeetingSettings;
var OofExternalAudience_1 = require("./Enumerations/OofExternalAudience");
exports.OofExternalAudience = OofExternalAudience_1.OofExternalAudience;
var OofReply_1 = require("./Misc/Availability/OofReply");
exports.OofReply = OofReply_1.OofReply;
var OofSettings_1 = require("./ComplexProperties/Availability/OofSettings");
exports.OofSettings = OofSettings_1.OofSettings;
var OofState_1 = require("./Enumerations/OofState");
exports.OofState = OofState_1.OofState;
var OrderByCollection_1 = require("./Search/OrderByCollection");
exports.OrderByCollection = OrderByCollection_1.OrderByCollection;
var OutlookAccount_1 = require("./Autodiscover/ConfigurationSettings/Outlook/OutlookAccount");
exports.OutlookAccount = OutlookAccount_1.OutlookAccount;
var OutlookConfigurationSettings_1 = require("./Autodiscover/ConfigurationSettings/Outlook/OutlookConfigurationSettings");
exports.OutlookConfigurationSettings = OutlookConfigurationSettings_1.OutlookConfigurationSettings;
var OutlookProtocol_1 = require("./Autodiscover/ConfigurationSettings/Outlook/OutlookProtocol");
exports.OutlookProtocol = OutlookProtocol_1.OutlookProtocol;
var OutlookProtocolType_1 = require("./Enumerations/OutlookProtocolType");
exports.OutlookProtocolType = OutlookProtocolType_1.OutlookProtocolType;
var OutlookUser_1 = require("./Autodiscover/ConfigurationSettings/Outlook/OutlookUser");
exports.OutlookUser = OutlookUser_1.OutlookUser;
var PagedView_1 = require("./Search/PagedView");
exports.PagedView = PagedView_1.PagedView;
var PartnerTokenCredentials_1 = require("./Credentials/PartnerTokenCredentials");
exports.PartnerTokenCredentials = PartnerTokenCredentials_1.PartnerTokenCredentials;
//export {PermissionSetPropertyDefinition} from "./PropertyDefinitions/PermissionCollectionPropertyDefinition";
var PermissionScope_1 = require("./Enumerations/PermissionScope");
exports.PermissionScope = PermissionScope_1.PermissionScope;
var PermissionSetPropertyDefinition_1 = require("./PropertyDefinitions/PermissionSetPropertyDefinition");
exports.PermissionSetPropertyDefinition = PermissionSetPropertyDefinition_1.PermissionSetPropertyDefinition;
//export {Persona} from "./operations/Persona/Persona";
var PersonaPostalAddress_1 = require("./ComplexProperties/PersonaPostalAddress");
exports.PersonaPostalAddress = PersonaPostalAddress_1.PersonaPostalAddress;
var PhoneCall_1 = require("./UnifiedMessaging/PhoneCall");
exports.PhoneCall = PhoneCall_1.PhoneCall;
var PhoneCallId_1 = require("./UnifiedMessaging/PhoneCallId");
exports.PhoneCallId = PhoneCallId_1.PhoneCallId;
var PhoneCallState_1 = require("./Enumerations/PhoneCallState");
exports.PhoneCallState = PhoneCallState_1.PhoneCallState;
var PhoneEntity_1 = require("./ComplexProperties/PhoneEntity");
exports.PhoneEntity = PhoneEntity_1.PhoneEntity;
var PhoneEntityCollection_1 = require("./ComplexProperties/PhoneEntityCollection");
exports.PhoneEntityCollection = PhoneEntityCollection_1.PhoneEntityCollection;
var PhoneNumberDictionary_1 = require("./ComplexProperties/PhoneNumberDictionary");
exports.PhoneNumberDictionary = PhoneNumberDictionary_1.PhoneNumberDictionary;
var PhoneNumberEntry_1 = require("./ComplexProperties/PhoneNumberEntry");
exports.PhoneNumberEntry = PhoneNumberEntry_1.PhoneNumberEntry;
var PhoneNumberKey_1 = require("./Enumerations/PhoneNumberKey");
exports.PhoneNumberKey = PhoneNumberKey_1.PhoneNumberKey;
var PhysicalAddressDictionary_1 = require("./ComplexProperties/PhysicalAddressDictionary");
exports.PhysicalAddressDictionary = PhysicalAddressDictionary_1.PhysicalAddressDictionary;
var PhysicalAddressEntry_1 = require("./ComplexProperties/PhysicalAddressEntry");
exports.PhysicalAddressEntry = PhysicalAddressEntry_1.PhysicalAddressEntry;
var PhysicalAddressIndex_1 = require("./Enumerations/PhysicalAddressIndex");
exports.PhysicalAddressIndex = PhysicalAddressIndex_1.PhysicalAddressIndex;
var PhysicalAddressKey_1 = require("./Enumerations/PhysicalAddressKey");
exports.PhysicalAddressKey = PhysicalAddressKey_1.PhysicalAddressKey;
var PlayOnPhoneRequest_1 = require("./Core/Requests/PlayOnPhoneRequest");
exports.PlayOnPhoneRequest = PlayOnPhoneRequest_1.PlayOnPhoneRequest;
var PlayOnPhoneResponse_1 = require("./Core/Responses/PlayOnPhoneResponse");
exports.PlayOnPhoneResponse = PlayOnPhoneResponse_1.PlayOnPhoneResponse;
var PolicyTag_1 = require("./ComplexProperties/PolicyTag");
exports.PolicyTag = PolicyTag_1.PolicyTag;
var PostItem_1 = require("./Core/ServiceObjects/Items/PostItem");
exports.PostItem = PostItem_1.PostItem;
var PostReply_1 = require("./Core/ServiceObjects/ResponseObjects/PostReply");
exports.PostReply = PostReply_1.PostReply;
var Presenters_1 = require("./Enumerations/Presenters");
exports.Presenters = Presenters_1.Presenters;
var PreviewItemBaseShape_1 = require("./Enumerations/PreviewItemBaseShape");
exports.PreviewItemBaseShape = PreviewItemBaseShape_1.PreviewItemBaseShape;
var PreviewItemMailbox_1 = require("./MailboxSearch/PreviewItemMailbox");
exports.PreviewItemMailbox = PreviewItemMailbox_1.PreviewItemMailbox;
var PreviewItemResponseShape_1 = require("./MailboxSearch/PreviewItemResponseShape");
exports.PreviewItemResponseShape = PreviewItemResponseShape_1.PreviewItemResponseShape;
var PrivilegedLogonType_1 = require("./Enumerations/PrivilegedLogonType");
exports.PrivilegedLogonType = PrivilegedLogonType_1.PrivilegedLogonType;
var PrivilegedUserId_1 = require("./Misc/PrivilegedUserId");
exports.PrivilegedUserId = PrivilegedUserId_1.PrivilegedUserId;
var PrivilegedUserIdBudgetType_1 = require("./Enumerations/PrivilegedUserIdBudgetType");
exports.PrivilegedUserIdBudgetType = PrivilegedUserIdBudgetType_1.PrivilegedUserIdBudgetType;
var PropertyBag_1 = require("./Core/PropertyBag");
exports.PropertyBag = PropertyBag_1.PropertyBag;
var PropertyDefinition_1 = require("./PropertyDefinitions/PropertyDefinition");
exports.PropertyDefinition = PropertyDefinition_1.PropertyDefinition;
var PropertyDefinitionBase_1 = require("./PropertyDefinitions/PropertyDefinitionBase");
exports.PropertyDefinitionBase = PropertyDefinitionBase_1.PropertyDefinitionBase;
var PropertyDefinitionFlags_1 = require("./Enumerations/PropertyDefinitionFlags");
exports.PropertyDefinitionFlags = PropertyDefinitionFlags_1.PropertyDefinitionFlags;
var PropertyException_1 = require("./Exceptions/PropertyException");
exports.PropertyException = PropertyException_1.PropertyException;
var PropertySet_1 = require("./Core/PropertySet");
exports.PropertySet = PropertySet_1.PropertySet;
var ProtocolConnection_1 = require("./Autodiscover/ProtocolConnection");
exports.ProtocolConnection = ProtocolConnection_1.ProtocolConnection;
var ProtocolConnectionCollection_1 = require("./Autodiscover/ProtocolConnectionCollection");
exports.ProtocolConnectionCollection = ProtocolConnectionCollection_1.ProtocolConnectionCollection;
var PullSubscription_1 = require("./Notifications/PullSubscription");
exports.PullSubscription = PullSubscription_1.PullSubscription;
var PushSubscription_1 = require("./Notifications/PushSubscription");
exports.PushSubscription = PushSubscription_1.PushSubscription;
var RecurrencePropertyDefinition_1 = require("./PropertyDefinitions/RecurrencePropertyDefinition");
exports.RecurrencePropertyDefinition = RecurrencePropertyDefinition_1.RecurrencePropertyDefinition;
var RecurrenceRange_1 = require("./ComplexProperties/Recurrence/Ranges/RecurrenceRange");
exports.RecurrenceRange = RecurrenceRange_1.RecurrenceRange;
var RecurringAppointmentMasterId_1 = require("./ComplexProperties/RecurringAppointmentMasterId");
exports.RecurringAppointmentMasterId = RecurringAppointmentMasterId_1.RecurringAppointmentMasterId;
//export {Reminder} from "./operations/ExchangeMailboxData/Reminder";
var RemoveDelegateRequest_1 = require("./Core/Requests/RemoveDelegateRequest");
exports.RemoveDelegateRequest = RemoveDelegateRequest_1.RemoveDelegateRequest;
var RemoveFromCalendar_1 = require("./Core/ServiceObjects/ResponseObjects/RemoveFromCalendar");
exports.RemoveFromCalendar = RemoveFromCalendar_1.RemoveFromCalendar;
var RenderingMode_1 = require("./Enumerations/RenderingMode");
exports.RenderingMode = RenderingMode_1.RenderingMode;
var ResolveNameSearchLocation_1 = require("./Enumerations/ResolveNameSearchLocation");
exports.ResolveNameSearchLocation = ResolveNameSearchLocation_1.ResolveNameSearchLocation;
var ResolveNamesRequest_1 = require("./Core/Requests/ResolveNamesRequest");
exports.ResolveNamesRequest = ResolveNamesRequest_1.ResolveNamesRequest;
var ResolveNamesResponse_1 = require("./Core/Responses/ResolveNamesResponse");
exports.ResolveNamesResponse = ResolveNamesResponse_1.ResolveNamesResponse;
var ResponseActions_1 = require("./Enumerations/ResponseActions");
exports.ResponseActions = ResponseActions_1.ResponseActions;
var ResponseMessage_1 = require("./Core/ServiceObjects/ResponseObjects/ResponseMessage");
exports.ResponseMessage = ResponseMessage_1.ResponseMessage;
var ResponseMessageType_1 = require("./Enumerations/ResponseMessageType");
exports.ResponseMessageType = ResponseMessageType_1.ResponseMessageType;
var ResponseObject_1 = require("./Core/ServiceObjects/ResponseObjects/ResponseObject");
exports.ResponseObject = ResponseObject_1.ResponseObject;
var ResponseObjectsPropertyDefinition_1 = require("./PropertyDefinitions/ResponseObjectsPropertyDefinition");
exports.ResponseObjectsPropertyDefinition = ResponseObjectsPropertyDefinition_1.ResponseObjectsPropertyDefinition;
var RetentionActionType_1 = require("./Enumerations/RetentionActionType");
exports.RetentionActionType = RetentionActionType_1.RetentionActionType;
var RetentionPolicyTag_1 = require("./Elc/RetentionPolicyTag");
exports.RetentionPolicyTag = RetentionPolicyTag_1.RetentionPolicyTag;
var RetentionTagBase_1 = require("./ComplexProperties/RetentionTagBase");
exports.RetentionTagBase = RetentionTagBase_1.RetentionTagBase;
var RetentionType_1 = require("./Enumerations/RetentionType");
exports.RetentionType = RetentionType_1.RetentionType;
var Rule_1 = require("./ComplexProperties/Rule");
exports.Rule = Rule_1.Rule;
var RuleActions_1 = require("./ComplexProperties/RuleActions");
exports.RuleActions = RuleActions_1.RuleActions;
var RuleCollection_1 = require("./ComplexProperties/RuleCollection");
exports.RuleCollection = RuleCollection_1.RuleCollection;
var RuleError_1 = require("./ComplexProperties/RuleError");
exports.RuleError = RuleError_1.RuleError;
var RuleErrorCode_1 = require("./Enumerations/RuleErrorCode");
exports.RuleErrorCode = RuleErrorCode_1.RuleErrorCode;
var RuleErrorCollection_1 = require("./ComplexProperties/RuleErrorCollection");
exports.RuleErrorCollection = RuleErrorCollection_1.RuleErrorCollection;
var RuleOperation_1 = require("./ComplexProperties/RuleOperation");
exports.RuleOperation = RuleOperation_1.RuleOperation;
var RuleOperationError_1 = require("./ComplexProperties/RuleOperationError");
exports.RuleOperationError = RuleOperationError_1.RuleOperationError;
var RuleOperationErrorCollection_1 = require("./ComplexProperties/RuleOperationErrorCollection");
exports.RuleOperationErrorCollection = RuleOperationErrorCollection_1.RuleOperationErrorCollection;
var RulePredicateDateRange_1 = require("./ComplexProperties/RulePredicateDateRange");
exports.RulePredicateDateRange = RulePredicateDateRange_1.RulePredicateDateRange;
var RulePredicates_1 = require("./ComplexProperties/RulePredicates");
exports.RulePredicates = RulePredicates_1.RulePredicates;
var RulePredicateSizeRange_1 = require("./ComplexProperties/RulePredicateSizeRange");
exports.RulePredicateSizeRange = RulePredicateSizeRange_1.RulePredicateSizeRange;
var RuleProperty_1 = require("./Enumerations/RuleProperty");
exports.RuleProperty = RuleProperty_1.RuleProperty;
//export {SafeXmlDocument} from "./Security/SafeXmlDocument";
var SafeXmlFactory_1 = require("./Security/SafeXmlFactory");
exports.SafeXmlFactory = SafeXmlFactory_1.SafeXmlFactory;
//export {SafeXmlSchema} from "./Security/SafeXmlSchema";
var ScopedDateTimePropertyDefinition_1 = require("./PropertyDefinitions/ScopedDateTimePropertyDefinition");
exports.ScopedDateTimePropertyDefinition = ScopedDateTimePropertyDefinition_1.ScopedDateTimePropertyDefinition;
var SearchableMailbox_1 = require("./MailboxSearch/SearchableMailbox");
exports.SearchableMailbox = SearchableMailbox_1.SearchableMailbox;
var SearchFolderParameters_1 = require("./ComplexProperties/SearchFolderParameters");
exports.SearchFolderParameters = SearchFolderParameters_1.SearchFolderParameters;
var SearchFolderTraversal_1 = require("./Enumerations/SearchFolderTraversal");
exports.SearchFolderTraversal = SearchFolderTraversal_1.SearchFolderTraversal;
var SearchMailboxesParameters_1 = require("./MailboxSearch/SearchMailboxesParameters");
exports.SearchMailboxesParameters = SearchMailboxesParameters_1.SearchMailboxesParameters;
var SearchMailboxesRequest_1 = require("./Core/Requests/SearchMailboxesRequest");
exports.SearchMailboxesRequest = SearchMailboxesRequest_1.SearchMailboxesRequest;
var SearchMailboxesResponse_1 = require("./Core/Responses/SearchMailboxesResponse");
exports.SearchMailboxesResponse = SearchMailboxesResponse_1.SearchMailboxesResponse;
var SearchMailboxesResult_1 = require("./MailboxSearch/SearchMailboxesResult");
exports.SearchMailboxesResult = SearchMailboxesResult_1.SearchMailboxesResult;
var SearchPageDirection_1 = require("./Enumerations/SearchPageDirection");
exports.SearchPageDirection = SearchPageDirection_1.SearchPageDirection;
var SearchPreviewItem_1 = require("./MailboxSearch/SearchPreviewItem");
exports.SearchPreviewItem = SearchPreviewItem_1.SearchPreviewItem;
var SearchRefinerItem_1 = require("./MailboxSearch/SearchRefinerItem");
exports.SearchRefinerItem = SearchRefinerItem_1.SearchRefinerItem;
var SearchResultType_1 = require("./Enumerations/SearchResultType");
exports.SearchResultType = SearchResultType_1.SearchResultType;
var SecurityTimestamp_1 = require("./Security/SecurityTimestamp");
exports.SecurityTimestamp = SecurityTimestamp_1.SecurityTimestamp;
var SeekToConditionItemView_1 = require("./Search/SeekToConditionItemView");
exports.SeekToConditionItemView = SeekToConditionItemView_1.SeekToConditionItemView;
var SendCancellationsMode_1 = require("./Enumerations/SendCancellationsMode");
exports.SendCancellationsMode = SendCancellationsMode_1.SendCancellationsMode;
var SendInvitationsMode_1 = require("./Enumerations/SendInvitationsMode");
exports.SendInvitationsMode = SendInvitationsMode_1.SendInvitationsMode;
var SendInvitationsOrCancellationsMode_1 = require("./Enumerations/SendInvitationsOrCancellationsMode");
exports.SendInvitationsOrCancellationsMode = SendInvitationsOrCancellationsMode_1.SendInvitationsOrCancellationsMode;
var SendItemRequest_1 = require("./Core/Requests/SendItemRequest");
exports.SendItemRequest = SendItemRequest_1.SendItemRequest;
var SendPrompt_1 = require("./Enumerations/SendPrompt");
exports.SendPrompt = SendPrompt_1.SendPrompt;
var Sensitivity_1 = require("./Enumerations/Sensitivity");
exports.Sensitivity = Sensitivity_1.Sensitivity;
var ServerBusyException_1 = require("./Exceptions/ServerBusyException");
exports.ServerBusyException = ServerBusyException_1.ServerBusyException;
//export {ServiceConfiguration} from "./operations/ServiceConfiguration/ServiceConfiguration";
var ServiceError_1 = require("./Enumerations/ServiceError");
exports.ServiceError = ServiceError_1.ServiceError;
var ServiceErrorHandling_1 = require("./Enumerations/ServiceErrorHandling");
exports.ServiceErrorHandling = ServiceErrorHandling_1.ServiceErrorHandling;
var ServiceId_1 = require("./ComplexProperties/ServiceId");
exports.ServiceId = ServiceId_1.ServiceId;
var ServiceJsonDeserializationException_1 = require("./Exceptions/ServiceJsonDeserializationException");
exports.ServiceJsonDeserializationException = ServiceJsonDeserializationException_1.ServiceJsonDeserializationException;
var ServiceLocalException_1 = require("./Exceptions/ServiceLocalException");
exports.ServiceLocalException = ServiceLocalException_1.ServiceLocalException;
var ServiceObjectInfo_1 = require("./Core/ServiceObjects/ServiceObjectInfo");
exports.ServiceObjectInfo = ServiceObjectInfo_1.ServiceObjectInfo;
var ServiceObjectPropertyDefinition_1 = require("./PropertyDefinitions/ServiceObjectPropertyDefinition");
exports.ServiceObjectPropertyDefinition = ServiceObjectPropertyDefinition_1.ServiceObjectPropertyDefinition;
var ServiceObjectPropertyException_1 = require("./Exceptions/ServiceObjectPropertyException");
exports.ServiceObjectPropertyException = ServiceObjectPropertyException_1.ServiceObjectPropertyException;
var ServiceObjectType_1 = require("./Enumerations/ServiceObjectType");
exports.ServiceObjectType = ServiceObjectType_1.ServiceObjectType;
var ServiceRemoteException_1 = require("./Exceptions/ServiceRemoteException");
exports.ServiceRemoteException = ServiceRemoteException_1.ServiceRemoteException;
var ServiceRequestBase_1 = require("./Core/Requests/ServiceRequestBase");
exports.ServiceRequestBase = ServiceRequestBase_1.ServiceRequestBase;
var ServiceRequestException_1 = require("./Exceptions/ServiceRequestException");
exports.ServiceRequestException = ServiceRequestException_1.ServiceRequestException;
var ServiceResponse_1 = require("./Core/Responses/ServiceResponse");
exports.ServiceResponse = ServiceResponse_1.ServiceResponse;
var ServiceResponseCollection_1 = require("./Core/Responses/ServiceResponseCollection");
exports.ServiceResponseCollection = ServiceResponseCollection_1.ServiceResponseCollection;
var ServiceResponseException_1 = require("./Exceptions/ServiceResponseException");
exports.ServiceResponseException = ServiceResponseException_1.ServiceResponseException;
var ServiceResult_1 = require("./Enumerations/ServiceResult");
exports.ServiceResult = ServiceResult_1.ServiceResult;
var ServiceValidationException_1 = require("./Exceptions/ServiceValidationException");
exports.ServiceValidationException = ServiceValidationException_1.ServiceValidationException;
var ServiceVersionException_1 = require("./Exceptions/ServiceVersionException");
exports.ServiceVersionException = ServiceVersionException_1.ServiceVersionException;
var ServiceXmlDeserializationException_1 = require("./Exceptions/ServiceXmlDeserializationException");
exports.ServiceXmlDeserializationException = ServiceXmlDeserializationException_1.ServiceXmlDeserializationException;
var ServiceXmlSerializationException_1 = require("./Exceptions/ServiceXmlSerializationException");
exports.ServiceXmlSerializationException = ServiceXmlSerializationException_1.ServiceXmlSerializationException;
var SetClientExtensionAction_1 = require("./ComplexProperties/SetClientExtensionAction");
exports.SetClientExtensionAction = SetClientExtensionAction_1.SetClientExtensionAction;
var SetClientExtensionActionId_1 = require("./Enumerations/SetClientExtensionActionId");
exports.SetClientExtensionActionId = SetClientExtensionActionId_1.SetClientExtensionActionId;
var SetClientExtensionRequest_1 = require("./Core/Requests/SetClientExtensionRequest");
exports.SetClientExtensionRequest = SetClientExtensionRequest_1.SetClientExtensionRequest;
var SetEncryptionConfigurationRequest_1 = require("./Core/Requests/SetEncryptionConfigurationRequest");
exports.SetEncryptionConfigurationRequest = SetEncryptionConfigurationRequest_1.SetEncryptionConfigurationRequest;
var SetEncryptionConfigurationResponse_1 = require("./Core/Responses/SetEncryptionConfigurationResponse");
exports.SetEncryptionConfigurationResponse = SetEncryptionConfigurationResponse_1.SetEncryptionConfigurationResponse;
var SetHoldOnMailboxesParameters_1 = require("./MailboxSearch/SetHoldOnMailboxesParameters");
exports.SetHoldOnMailboxesParameters = SetHoldOnMailboxesParameters_1.SetHoldOnMailboxesParameters;
var SetHoldOnMailboxesRequest_1 = require("./Core/Requests/SetHoldOnMailboxesRequest");
exports.SetHoldOnMailboxesRequest = SetHoldOnMailboxesRequest_1.SetHoldOnMailboxesRequest;
var SetHoldOnMailboxesResponse_1 = require("./Core/Responses/SetHoldOnMailboxesResponse");
exports.SetHoldOnMailboxesResponse = SetHoldOnMailboxesResponse_1.SetHoldOnMailboxesResponse;
var SetRuleOperation_1 = require("./ComplexProperties/SetRuleOperation");
exports.SetRuleOperation = SetRuleOperation_1.SetRuleOperation;
var SetTeamMailboxRequest_1 = require("./Core/Requests/SetTeamMailboxRequest");
exports.SetTeamMailboxRequest = SetTeamMailboxRequest_1.SetTeamMailboxRequest;
var SetUserOofSettingsRequest_1 = require("./Core/Requests/SetUserOofSettingsRequest");
exports.SetUserOofSettingsRequest = SetUserOofSettingsRequest_1.SetUserOofSettingsRequest;
//export {Sharing} from "./operations/Sharing/Sharing";
var SimplePropertyBag_1 = require("./Core/SimplePropertyBag");
exports.SimplePropertyBag = SimplePropertyBag_1.SimplePropertyBag;
var SimpleServiceRequestBase_1 = require("./Core/Requests/SimpleServiceRequestBase");
exports.SimpleServiceRequestBase = SimpleServiceRequestBase_1.SimpleServiceRequestBase;
var SoapFaultDetails_1 = require("./Misc/SoapFaultDetails");
exports.SoapFaultDetails = SoapFaultDetails_1.SoapFaultDetails;
var SortDirection_1 = require("./Enumerations/SortDirection");
exports.SortDirection = SortDirection_1.SortDirection;
var StandardUser_1 = require("./Enumerations/StandardUser");
exports.StandardUser = StandardUser_1.StandardUser;
var StartTimeZonePropertyDefinition_1 = require("./PropertyDefinitions/StartTimeZonePropertyDefinition");
exports.StartTimeZonePropertyDefinition = StartTimeZonePropertyDefinition_1.StartTimeZonePropertyDefinition;
var StreamingSubscription_1 = require("./Notifications/StreamingSubscription");
exports.StreamingSubscription = StreamingSubscription_1.StreamingSubscription;
var StreamingSubscriptionConnection_1 = require("./Notifications/StreamingSubscriptionConnection");
exports.StreamingSubscriptionConnection = StreamingSubscriptionConnection_1.StreamingSubscriptionConnection;
var StringList_1 = require("./ComplexProperties/StringList");
exports.StringList = StringList_1.StringList;
var StringPropertyDefinition_1 = require("./PropertyDefinitions/StringPropertyDefinition");
exports.StringPropertyDefinition = StringPropertyDefinition_1.StringPropertyDefinition;
var Strings_1 = require("./Strings");
exports.Strings = Strings_1.Strings;
var SubscribeRequest_1 = require("./Core/Requests/SubscribeRequest");
exports.SubscribeRequest = SubscribeRequest_1.SubscribeRequest;
var SubscribeResponse_1 = require("./Core/Responses/SubscribeResponse");
exports.SubscribeResponse = SubscribeResponse_1.SubscribeResponse;
var SubscribeToPullNotificationsRequest_1 = require("./Core/Requests/SubscribeToPullNotificationsRequest");
exports.SubscribeToPullNotificationsRequest = SubscribeToPullNotificationsRequest_1.SubscribeToPullNotificationsRequest;
var SubscribeToPushNotificationsRequest_1 = require("./Core/Requests/SubscribeToPushNotificationsRequest");
exports.SubscribeToPushNotificationsRequest = SubscribeToPushNotificationsRequest_1.SubscribeToPushNotificationsRequest;
var SubscribeToStreamingNotificationsRequest_1 = require("./Core/Requests/SubscribeToStreamingNotificationsRequest");
exports.SubscribeToStreamingNotificationsRequest = SubscribeToStreamingNotificationsRequest_1.SubscribeToStreamingNotificationsRequest;
var SubscriptionBase_1 = require("./Notifications/SubscriptionBase");
exports.SubscriptionBase = SubscriptionBase_1.SubscriptionBase;
var SubscriptionErrorEventArgs_1 = require("./Notifications/SubscriptionErrorEventArgs");
exports.SubscriptionErrorEventArgs = SubscriptionErrorEventArgs_1.SubscriptionErrorEventArgs;
var Suggestion_1 = require("./ComplexProperties/Availability/Suggestion");
exports.Suggestion = Suggestion_1.Suggestion;
var SuggestionQuality_1 = require("./Enumerations/SuggestionQuality");
exports.SuggestionQuality = SuggestionQuality_1.SuggestionQuality;
var SuggestionsResponse_1 = require("./Core/Responses/SuggestionsResponse");
exports.SuggestionsResponse = SuggestionsResponse_1.SuggestionsResponse;
var SuppressReadReceipt_1 = require("./Core/ServiceObjects/ResponseObjects/SuppressReadReceipt");
exports.SuppressReadReceipt = SuppressReadReceipt_1.SuppressReadReceipt;
var SyncFolderHierarchyRequest_1 = require("./Core/Requests/SyncFolderHierarchyRequest");
exports.SyncFolderHierarchyRequest = SyncFolderHierarchyRequest_1.SyncFolderHierarchyRequest;
var SyncFolderHierarchyResponse_1 = require("./Core/Responses/SyncFolderHierarchyResponse");
exports.SyncFolderHierarchyResponse = SyncFolderHierarchyResponse_1.SyncFolderHierarchyResponse;
var SyncFolderItemsRequest_1 = require("./Core/Requests/SyncFolderItemsRequest");
exports.SyncFolderItemsRequest = SyncFolderItemsRequest_1.SyncFolderItemsRequest;
var SyncFolderItemsResponse_1 = require("./Core/Responses/SyncFolderItemsResponse");
exports.SyncFolderItemsResponse = SyncFolderItemsResponse_1.SyncFolderItemsResponse;
var SyncFolderItemsScope_1 = require("./Enumerations/SyncFolderItemsScope");
exports.SyncFolderItemsScope = SyncFolderItemsScope_1.SyncFolderItemsScope;
var SyncResponse_1 = require("./Core/Responses/SyncResponse");
exports.SyncResponse = SyncResponse_1.SyncResponse;
var Task_1 = require("./Core/ServiceObjects/Items/Task");
exports.Task = Task_1.Task;
var TaskDelegationState_1 = require("./Enumerations/TaskDelegationState");
exports.TaskDelegationState = TaskDelegationState_1.TaskDelegationState;
var TaskDelegationStatePropertyDefinition_1 = require("./PropertyDefinitions/TaskDelegationStatePropertyDefinition");
exports.TaskDelegationStatePropertyDefinition = TaskDelegationStatePropertyDefinition_1.TaskDelegationStatePropertyDefinition;
var TaskMode_1 = require("./Enumerations/TaskMode");
exports.TaskMode = TaskMode_1.TaskMode;
var TaskStatus_1 = require("./Enumerations/TaskStatus");
exports.TaskStatus = TaskStatus_1.TaskStatus;
var TaskSuggestion_1 = require("./ComplexProperties/TaskSuggestion");
exports.TaskSuggestion = TaskSuggestion_1.TaskSuggestion;
var TaskSuggestionCollection_1 = require("./ComplexProperties/TaskSuggestionCollection");
exports.TaskSuggestionCollection = TaskSuggestionCollection_1.TaskSuggestionCollection;
var TeamMailboxLifecycleState_1 = require("./Enumerations/TeamMailboxLifecycleState");
exports.TeamMailboxLifecycleState = TeamMailboxLifecycleState_1.TeamMailboxLifecycleState;
var TextBody_1 = require("./ComplexProperties/TextBody");
exports.TextBody = TextBody_1.TextBody;
var Time_1 = require("./Misc/Time");
exports.Time = Time_1.Time;
var TimeChange_1 = require("./ComplexProperties/TimeChange");
exports.TimeChange = TimeChange_1.TimeChange;
var TimeChangeRecurrence_1 = require("./ComplexProperties/TimeChangeRecurrence");
exports.TimeChangeRecurrence = TimeChangeRecurrence_1.TimeChangeRecurrence;
var TimeSpanPropertyDefinition_1 = require("./PropertyDefinitions/TimeSpanPropertyDefinition");
exports.TimeSpanPropertyDefinition = TimeSpanPropertyDefinition_1.TimeSpanPropertyDefinition;
var TimeSuggestion_1 = require("./ComplexProperties/Availability/TimeSuggestion");
exports.TimeSuggestion = TimeSuggestion_1.TimeSuggestion;
var TimeWindow_1 = require("./Misc/Availability/TimeWindow");
exports.TimeWindow = TimeWindow_1.TimeWindow;
var TimeZoneConversionException_1 = require("./Exceptions/TimeZoneConversionException");
exports.TimeZoneConversionException = TimeZoneConversionException_1.TimeZoneConversionException;
var TimeZonePropertyDefinition_1 = require("./PropertyDefinitions/TimeZonePropertyDefinition");
exports.TimeZonePropertyDefinition = TimeZonePropertyDefinition_1.TimeZonePropertyDefinition;
var TimeZoneTransitionGroup_1 = require("./ComplexProperties/TimeZones/TimeZoneTransitionGroup");
exports.TimeZoneTransitionGroup = TimeZoneTransitionGroup_1.TimeZoneTransitionGroup;
var TokenCredentials_1 = require("./Credentials/TokenCredentials");
exports.TokenCredentials = TokenCredentials_1.TokenCredentials;
var TraceFlags_1 = require("./Enumerations/TraceFlags");
exports.TraceFlags = TraceFlags_1.TraceFlags;
var TypedPropertyDefinition_1 = require("./PropertyDefinitions/TypedPropertyDefinition");
exports.TypedPropertyDefinition = TypedPropertyDefinition_1.TypedPropertyDefinition;
//export {UnifiedContactStore} from "./operations/UnifiedContactStore/UnifiedContactStore";
var UnifiedMessaging_1 = require("./UnifiedMessaging/UnifiedMessaging");
exports.UnifiedMessaging = UnifiedMessaging_1.UnifiedMessaging;
var UninstallAppRequest_1 = require("./Core/Requests/UninstallAppRequest");
exports.UninstallAppRequest = UninstallAppRequest_1.UninstallAppRequest;
var UninstallAppResponse_1 = require("./Core/Responses/UninstallAppResponse");
exports.UninstallAppResponse = UninstallAppResponse_1.UninstallAppResponse;
var UniqueBody_1 = require("./ComplexProperties/UniqueBody");
exports.UniqueBody = UniqueBody_1.UniqueBody;
var UnpinTeamMailboxRequest_1 = require("./Core/Requests/UnpinTeamMailboxRequest");
exports.UnpinTeamMailboxRequest = UnpinTeamMailboxRequest_1.UnpinTeamMailboxRequest;
var UnsubscribeRequest_1 = require("./Core/Requests/UnsubscribeRequest");
exports.UnsubscribeRequest = UnsubscribeRequest_1.UnsubscribeRequest;
var UpdateDelegateRequest_1 = require("./Core/Requests/UpdateDelegateRequest");
exports.UpdateDelegateRequest = UpdateDelegateRequest_1.UpdateDelegateRequest;
var UpdateFolderRequest_1 = require("./Core/Requests/UpdateFolderRequest");
exports.UpdateFolderRequest = UpdateFolderRequest_1.UpdateFolderRequest;
var UpdateFolderResponse_1 = require("./Core/Responses/UpdateFolderResponse");
exports.UpdateFolderResponse = UpdateFolderResponse_1.UpdateFolderResponse;
var UpdateInboxRulesException_1 = require("./Exceptions/UpdateInboxRulesException");
exports.UpdateInboxRulesException = UpdateInboxRulesException_1.UpdateInboxRulesException;
var UpdateInboxRulesRequest_1 = require("./Core/Requests/UpdateInboxRulesRequest");
exports.UpdateInboxRulesRequest = UpdateInboxRulesRequest_1.UpdateInboxRulesRequest;
var UpdateInboxRulesResponse_1 = require("./Core/Responses/UpdateInboxRulesResponse");
exports.UpdateInboxRulesResponse = UpdateInboxRulesResponse_1.UpdateInboxRulesResponse;
var UpdateItemRequest_1 = require("./Core/Requests/UpdateItemRequest");
exports.UpdateItemRequest = UpdateItemRequest_1.UpdateItemRequest;
var UpdateItemResponse_1 = require("./Core/Responses/UpdateItemResponse");
exports.UpdateItemResponse = UpdateItemResponse_1.UpdateItemResponse;
var UpdateUserConfigurationRequest_1 = require("./Core/Requests/UpdateUserConfigurationRequest");
exports.UpdateUserConfigurationRequest = UpdateUserConfigurationRequest_1.UpdateUserConfigurationRequest;
var Uri_1 = require("./Uri");
exports.Uri = Uri_1.Uri;
var UrlEntity_1 = require("./ComplexProperties/UrlEntity");
exports.UrlEntity = UrlEntity_1.UrlEntity;
var UrlEntityCollection_1 = require("./ComplexProperties/UrlEntityCollection");
exports.UrlEntityCollection = UrlEntityCollection_1.UrlEntityCollection;
var UserConfiguration_1 = require("./Misc/UserConfiguration");
exports.UserConfiguration = UserConfiguration_1.UserConfiguration;
var UserConfigurationDictionary_1 = require("./ComplexProperties/UserConfigurationDictionary");
exports.UserConfigurationDictionary = UserConfigurationDictionary_1.UserConfigurationDictionary;
var UserConfigurationDictionaryObjectType_1 = require("./Enumerations/UserConfigurationDictionaryObjectType");
exports.UserConfigurationDictionaryObjectType = UserConfigurationDictionaryObjectType_1.UserConfigurationDictionaryObjectType;
var UserConfigurationProperties_1 = require("./Enumerations/UserConfigurationProperties");
exports.UserConfigurationProperties = UserConfigurationProperties_1.UserConfigurationProperties;
var UserId_1 = require("./ComplexProperties/UserId");
exports.UserId = UserId_1.UserId;
var UserSettingError_1 = require("./Autodiscover/UserSettingError");
exports.UserSettingError = UserSettingError_1.UserSettingError;
var UserSettingName_1 = require("./Enumerations/UserSettingName");
exports.UserSettingName = UserSettingName_1.UserSettingName;
//export {Utilities} from "./operations/ExchangeMailboxData/Utilities";
var Versioning_1 = require("./MailboxSearch/Versioning");
exports.DiscoverySchemaChanges = Versioning_1.DiscoverySchemaChanges;
var ViewBase_1 = require("./Search/ViewBase");
exports.ViewBase = ViewBase_1.ViewBase;
var ViewFilter_1 = require("./Enumerations/ViewFilter");
exports.ViewFilter = ViewFilter_1.ViewFilter;
var VotingInformation_1 = require("./ComplexProperties/VotingInformation");
exports.VotingInformation = VotingInformation_1.VotingInformation;
var VotingOptionData_1 = require("./ComplexProperties/VotingOptionData");
exports.VotingOptionData = VotingOptionData_1.VotingOptionData;
var WebClientUrl_1 = require("./Autodiscover/WebClientUrl");
exports.WebClientUrl = WebClientUrl_1.WebClientUrl;
var WebClientUrlCollection_1 = require("./Autodiscover/WebClientUrlCollection");
exports.WebClientUrlCollection = WebClientUrlCollection_1.WebClientUrlCollection;
var WebCredentials_1 = require("./Credentials/WebCredentials");
exports.WebCredentials = WebCredentials_1.WebCredentials;
var WellKnownFolderName_1 = require("./Enumerations/WellKnownFolderName");
exports.WellKnownFolderName = WellKnownFolderName_1.WellKnownFolderName;
var WindowsLiveCredentials_1 = require("./Credentials/WindowsLiveCredentials");
exports.WindowsLiveCredentials = WindowsLiveCredentials_1.WindowsLiveCredentials;
var WorkingHours_1 = require("./ComplexProperties/Availability/WorkingHours");
exports.WorkingHours = WorkingHours_1.WorkingHours;
var WorkingPeriod_1 = require("./ComplexProperties/Availability/WorkingPeriod");
exports.WorkingPeriod = WorkingPeriod_1.WorkingPeriod;
var WSSecurityBasedCredentials_1 = require("./Credentials/WSSecurityBasedCredentials");
exports.WSSecurityBasedCredentials = WSSecurityBasedCredentials_1.WSSecurityBasedCredentials;
var WSSecurityUtilityIdSignedXml_1 = require("./Credentials/WSSecurityUtilityIdSignedXml");
exports.WSSecurityUtilityIdSignedXml = WSSecurityUtilityIdSignedXml_1.WSSecurityUtilityIdSignedXml;
var X509CertificateCredentials_1 = require("./Credentials/X509CertificateCredentials");
exports.X509CertificateCredentials = X509CertificateCredentials_1.X509CertificateCredentials;
var XmlAttributeNames_1 = require("./Core/XmlAttributeNames");
exports.XmlAttributeNames = XmlAttributeNames_1.XmlAttributeNames;
//export {XmlDtdException} from "./Security/XmlDtdException";
var XmlElementNames_1 = require("./Core/XmlElementNames");
exports.XmlElementNames = XmlElementNames_1.XmlElementNames;
var XmlNamespace_1 = require("./Enumerations/XmlNamespace");
exports.XmlNamespace = XmlNamespace_1.XmlNamespace;
//# sourceMappingURL=ExchangeWebService.js.map