"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @internal EwsTraceListener logs request/responses to a text writer.
 */
var EwsTraceListener = /** @class */ (function () {
    function EwsTraceListener(writer) {
        if (writer === void 0) { writer = { Write: console.log }; }
        this.writer = null;
        this.writer = writer;
    }
    /**
     * Handles a trace message
     *
     * @param   {string}   traceType      Type of trace message.
     * @param   {string}   traceMessage   The trace message.
     */
    EwsTraceListener.prototype.Trace = function (traceType, traceMessage) {
        this.writer.Write(traceMessage);
    };
    return EwsTraceListener;
}());
exports.EwsTraceListener = EwsTraceListener;
//# sourceMappingURL=EwsTraceListener.js.map